/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Locale;
import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

public class Calendario extends Composite {
	private Vector<Label> etiquetas = new Vector<Label>();
	private Vector<Integer> fechas = new Vector<Integer>();
	private Vector<String> idsEvento = new Vector<String>();
	private Calendar fechaHoyCalendario = null;
	public Calendario(Composite parent, int style) {super(parent, style);initialize();}
	
	public void actualizar(){
		actualizarDiasNoLectivosClase();
		actualizarEtiquetaDiaHoy();
	}
	private void initialize() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		GridLayout gridLayoutCalendario = new GridLayout();
		gridLayoutCalendario.horizontalSpacing = 2;
		gridLayoutCalendario.verticalSpacing = 2;
		gridLayoutCalendario.marginWidth = 2;
		gridLayoutCalendario.marginHeight = 2;
		gridLayoutCalendario.numColumns = Fecha.MesesPorFilaCalendario;
		GridData gridDataCalendario = new GridData();
		gridDataCalendario.grabExcessHorizontalSpace = true;
		gridDataCalendario.grabExcessVerticalSpace = true;
		gridDataCalendario.horizontalAlignment = GridData.FILL;
		gridDataCalendario.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataCalendario);
		this.setLayout(gridLayoutCalendario);
		this.setSize(new Point(685, 340));
		Calendar fecha = (Calendar)Fecha.inicioCurso.clone();
		for (int i=0;i<Fecha.MesesLectivosCalendario;i++) {
			GridData gridDataCalendarioMes = new GridData();
			gridDataCalendarioMes.grabExcessHorizontalSpace = true;
			gridDataCalendarioMes.grabExcessVerticalSpace = true;
			gridDataCalendarioMes.horizontalAlignment = GridData.FILL;
			gridDataCalendarioMes.verticalAlignment = GridData.FILL;
			GridLayout gridLayoutCalendarioMes = new GridLayout();
			gridLayoutCalendarioMes.numColumns = Fecha.NDiasSemana;
			gridLayoutCalendarioMes.horizontalSpacing = 1;
			gridLayoutCalendarioMes.verticalSpacing = 1;
			gridLayoutCalendarioMes.marginWidth = 0;
			gridLayoutCalendarioMes.marginHeight = 0;
			Composite compositeCalendarioMes = new Composite(this, SWT.BORDER);
			compositeCalendarioMes.setLayout(gridLayoutCalendarioMes);
			compositeCalendarioMes.setLayoutData(gridDataCalendarioMes);
			compositeCalendarioMes.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
			Label labelCalendarioMes = new Label(compositeCalendarioMes, SWT.CENTER | SWT.SHADOW_OUT);
	        GridData gridDataLabelCalendarioMes = new GridData(GridData.FILL_HORIZONTAL);
	        gridDataLabelCalendarioMes.horizontalSpan = Fecha.NDiasSemana;
	        labelCalendarioMes.setLayoutData(gridDataLabelCalendarioMes);
	        labelCalendarioMes.setText(fecha.getDisplayName(Calendar.MONTH, Calendar.LONG , Locale.getDefault())+" "+fecha.get(Calendar.YEAR));
			labelCalendarioMes.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
			labelCalendarioMes.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
	        boolean preRelleno=true,postRelleno=false;
	        //System.out.println("Calendario initialize fecha:"+fecha.get(Calendar.DAY_OF_MONTH)+"/"+fecha.get(Calendar.MONTH)+"/"+fecha.get(Calendar.YEAR));
	        for (int j=0;j<42;j++){
				GridData gridDataLabelDiaCalendario = new GridData();
				gridDataLabelDiaCalendario.grabExcessHorizontalSpace = true;
				gridDataLabelDiaCalendario.grabExcessVerticalSpace = true;
				gridDataLabelDiaCalendario.horizontalAlignment = GridData.FILL;
				gridDataLabelDiaCalendario.verticalAlignment = GridData.FILL;
	        	Label labelDiaCalendario = new Label(compositeCalendarioMes, SWT.CENTER);
	        	labelDiaCalendario.setLayoutData(gridDataLabelDiaCalendario);
	        	int columnaEtiqueta=(j%Fecha.NDiasSemana);
	        	int diaSemanaEtiqueta=((columnaEtiqueta+Fecha.PrimerDiaSemanaLaboral<=Fecha.NDiasSemana)?columnaEtiqueta+Fecha.PrimerDiaSemanaLaboral:columnaEtiqueta-(Fecha.NDiasSemana - Fecha.PrimerDiaSemanaLaboral));
	        	//System.out.println("Calendario initialize  columna = "+columnaEtiqueta+", 1erDiaSemanaLaboral = "+Fecha.PrimerDiaSemanaLaboral+", DiasSemana = "+Fecha.DiasSemana+", diaSemanaEtiqueta = "+diaSemanaEtiqueta);
	        	if (preRelleno && (fecha.get(Calendar.DAY_OF_WEEK)==diaSemanaEtiqueta)) preRelleno=false;
        		//System.out.println("Calendario initialize  dia "+fecha.get(Calendar.DAY_OF_MONTH)+"/"+fecha.get(Calendar.MONTH)+"/"+fecha.get(Calendar.YEAR)+" ["+preRelleno+","+postRelleno+"]: ("+fecha.get(Calendar.DAY_OF_WEEK)+","+primerDiaSemana+") "+((fecha.get(Calendar.DAY_OF_WEEK)>=primerDiaSemana)?fecha.get(Calendar.DAY_OF_WEEK)-primerDiaSemana:fecha.get(Calendar.DAY_OF_WEEK)+(7-primerDiaSemana))+"=="+(j%7)+". dias maximo mes = "+fecha.getMaximum(Calendar.DAY_OF_MONTH));
	        	if (preRelleno || postRelleno) {
	        		labelDiaCalendario.setText("");
	        		if (Fecha.diaSemanaFestivo(diaSemanaEtiqueta)) {
	        			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
	        		} else {
	    				labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
	        		}
	        	} else {
	        		labelDiaCalendario.setText(Integer.toString(fecha.get(Calendar.DAY_OF_MONTH)));
	        		etiquetas.add(labelDiaCalendario);
	        		fechas.add(Fecha.formaFechaInt(fecha));
	        		idsEvento.add("");
	        		if (Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
	    				labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
	        			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
	        		} else {
	    				labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
	        			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
	        		}
	        		final String idEvento=String.valueOf(etiquetas.size()-1);
	        		labelDiaCalendario.addMouseListener(new org.eclipse.swt.events.MouseAdapter() {
						public void mouseUp(org.eclipse.swt.events.MouseEvent e) {
							if (!idsEvento.get(Integer.parseInt(idEvento)).equals("")) {
								//System.out.println("Calendario initialize Visualizando evento: "+idsEvento.get(Integer.parseInt(idEvento)));
								PCuaderno.MiPCuaderno.seleccionarFicha(PCuaderno.MiPCuaderno.tituloEventos);
								PCuaderno.MiPCuaderno.evento.seleccionarEvento(idsEvento.get(Integer.parseInt(idEvento)));
							}
						}
					});
	        		//System.out.println("Calendario initialize etiquetaDia "+ Fecha.formaFechaDia(fecha));
        			fecha.add(Calendar.DAY_OF_MONTH, 1);
	        		if (fecha.get(Calendar.DAY_OF_MONTH)==1){ postRelleno=true;}
	        	}
	        }
		}
		ponerDiasNoLectivos();
		ponerEventosCalendario();
		actualizarEtiquetaDiaHoy();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("fin",true);
	}
	public void actualizarCalendario(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		Calendar fecha = (Calendar)Fecha.inicioCurso.clone();
		for (;fecha.compareTo(Fecha.finCurso)<=0;fecha.add(Calendar.DAY_OF_MONTH, 1)) {
			fecha=Fecha.fechaHoraCero(fecha);
			int indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
			Label labelDiaCalendario = etiquetas.get(indice);
			idsEvento.set(indice, "");
    		if (Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
				labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
    			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
    		} else {
				labelDiaCalendario.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
    			labelDiaCalendario.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
    		}
		}
		ponerDiasNoLectivos();
		actualizarDiasNoLectivosClase();
		ponerEventosCalendario();
		fechaHoyCalendario = null;
		actualizarEtiquetaDiaHoy();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin");
	}
	public void actualizarEtiquetaDiaHoy(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		int indice=0;
    	if (fechaHoyCalendario==null) {
    		fechaHoyCalendario=Calendar.getInstance();
    		fechaHoyCalendario=Fecha.fechaHoraCero(fechaHoyCalendario);
    	} else {
    		Calendar fechaHoy=Calendar.getInstance();
    		fechaHoy=Fecha.fechaHoraCero(fechaHoy);
    		if (fechaHoy.compareTo(fechaHoyCalendario)!=0) {
    			if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Calendario actualizarEtiquetaDiaHoy Actualizando dia de hoy ("+Fecha.formaFecha(fechaHoy)+") ...");
    			actualizarEtiquetaDia(fechaHoyCalendario);
    			fechaHoyCalendario=fechaHoy;
    		}
    	}
		indice=fechas.indexOf(Fecha.formaFechaInt(fechaHoyCalendario));
		Label etiqueta=etiquetas.get(indice);
		if (idsEvento.get(indice).equals(""))
			if (!Fecha.diaLaboral(fechaHoyCalendario, true))
				etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
			else
				etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
		etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+Fecha.formaFecha(fechaHoyCalendario),true);
	}
	public void actualizarEtiquetaDia(Calendar fecha){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+Fecha.formaFecha(fechaHoyCalendario)+")");
		Vector<Vector<String>> eventos;
		fecha=Fecha.fechaHoraCero(fecha);
		int indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
		Label etiqueta=etiquetas.get(indice);
		etiqueta.setToolTipText("");
		if (Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
			etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
			etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
		} else {
   			boolean lectivo=true;
			Vector<Vector<String>> diaNoLectivo=BBDD.consultarDiaNoLectivo(fecha);
			//System.out.println("Calendario actualizarEtiquetaDia Descripcion noLectivo ("+diaNoLectivo.get(0).get(3)+") ...");
	   		if (diaNoLectivo!=null) if (diaNoLectivo.size()>0){
	   			String claseNoLectivo=null;
	   			String clase=null;
	   			String emergente="";
	   			for (int i=0;i<diaNoLectivo.size();i++){
		   			if (diaNoLectivo.get(i).get(1)==null){
		   				claseNoLectivo="NULL";
		   			} else {
		   				claseNoLectivo=diaNoLectivo.get(i).get(1);
		   				clase=MateriaClase.formaClase(MateriaClase.getIdClaseDeTrabajo());
		   			}
		   			if (claseNoLectivo.equals("NULL") || claseNoLectivo.equals(MateriaClase.getIdClaseDeTrabajo())) {
						etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
			   			etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
			   			if (emergente.isEmpty()) emergente="El dia "+Fecha.formaFechaDia(fecha)+":";
		   				emergente+="\nNo Lectivo: "+((clase!=null)?"("+clase+") ":"")+diaNoLectivo.get(i).get(5);
		   				lectivo=false;
		   			}
	   			}
	   			if (!emergente.isEmpty()) etiqueta.setToolTipText(emergente);
	   		}
	   		if (lectivo){
				etiqueta.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
	   			etiqueta.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
	    	}
		}
		idsEvento.set(indice,"");
		eventos=BBDD.consultarEventosTipoDia(null,fecha);
		for (int i=0;i<eventos.size();i++){
			actualizarEvento(eventos.get(i));
		} 
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+Fecha.formaFecha(fechaHoyCalendario)+") fin");
	}
	public void ponerEventosCalendario(){ //Dejar de utilizar
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> eventos;
		eventos=BBDD.consultarEventosTipoDesdeFecha(null,Fecha.inicioCurso);
		for (int i=0;i<eventos.size();i++){
			//System.out.println("Calendario ponerEventosCalendario Dia evento: "+eventos.get(i).get(0)+" info="+eventos.get(i).get(9));
			actualizarEvento(eventos.get(i));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin",true);
	}
	public void actualizarEvento(Vector<String> evento){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		//BBDD.imprimirRegistro(evento);
		//El color y evento click será del primer evento del día
		Vector<Vector<String>> eventoTipo;
		Calendar fecha = Fecha.fecha(evento.get(1),evento.get(2),evento.get(3));
		int indice=fechas.indexOf(Fecha.formaFechaInt(fecha));
		Label etiqueta=etiquetas.get(indice);
		//System.out.println("Calendario actualizarEvento Actualizando evento en Calendario (id "+evento.get(0)+", "+Fecha.formaFecha(fecha)+")...");
		if (etiqueta!=null) {
			if (idsEvento.get(indice).equals("")) {
				final String idEvento=evento.get(0);
				idsEvento.set(indice, idEvento);
				//System.out.println("Calendario actualizarEvento Actualizando etiqueta ("+indice+") id="+idEvento);
				etiqueta.setForeground(Display.getCurrent().getSystemColor(Integer.parseInt(evento.get(11))));
			}
			String info="+ a las "+Fecha.formaHora(evento.get(4),evento.get(5));
			eventoTipo=BBDD.consultarEventoTipoDatos(evento.get(0),Integer.parseInt(evento.get(9)));
			//BBDD.imprimir(eventoTipo);
			switch (Integer.parseInt(evento.get(9))) {
				case BBDD.idTipoEvaluacion:
					info+=" "+evento.get(10)+" "+eventoTipo.get(0).get(3)+"º"+eventoTipo.get(0).get(4)+" "+eventoTipo.get(0).get(5);
					break;
				case BBDD.idTipoClaustro:
					info+=" "+evento.get(10)+" "+((eventoTipo.get(0).get(1).equals(BBDD.verdadero))?BBDD.ordinario:BBDD.extraordinario);
					break;
				case BBDD.idTipoConsejoEscolar: 
					info+=" "+evento.get(10)+" "+((eventoTipo.get(0).get(1).equals(BBDD.verdadero))?BBDD.ordinario:BBDD.extraordinario);
					break;
				case BBDD.idTipoETCP:
					info+=" "+evento.get(10);
					break;
				case BBDD.idTipoCitaConTutores:
					info+=" "+evento.get(10)+" ("+eventoTipo.get(0).get(1)+"):";
					Vector<Vector<String>> estudiantes = BBDD.consultarEstudiantesCitaTutores(evento.get(0));
					for (int j=0;j<estudiantes.size();j++){
						info+="\n  -"+estudiantes.get(j).get(2)+", "+estudiantes.get(j).get(1);
					}
					break;
				case BBDD.idTipoOtroTipo:
					info+=" "+evento.get(10);
					break;
			}
			if (etiqueta.getToolTipText()==null) {
				etiqueta.setToolTipText("El dia "+Fecha.formaFechaDia(Fecha.fecha(evento.get(1),evento.get(2),evento.get(3)))+":\n"+info);
			} else if (etiqueta.getToolTipText().equals("")){
				etiqueta.setToolTipText("El dia "+Fecha.formaFechaDia(Fecha.fecha(evento.get(1),evento.get(2),evento.get(3)))+":\n"+info);
			} else etiqueta.setToolTipText(etiqueta.getToolTipText()+"\n"+info);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin");
	}
	public void ponerDiasNoLectivos(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> dias;
		Label etiquetaDia;
		dias=BBDD.consultarDiasNoLectivosDiaCompletoYClase(null);
		for (int i=0;i<dias.size();i++){
			//System.out.print("Calendario ponerDiasNoLectivos Dia: "+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+" = "+dias.get(i).get(5)+".");
			int indice=fechas.indexOf(Fecha.formaFechaInt(Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))));
			if (indice>=0) {
				etiquetaDia=etiquetas.get(indice);
				if (etiquetaDia!=null) {
					etiquetaDia.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
					etiquetaDia.setToolTipText("El dia "+Fecha.formaFechaDia(Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4)))+":\nNo Lectivo: "+dias.get(i).get(5));
					//System.out.println("ok");
				} else System.out.println("Calendario.ponerDiasNoLectivos - etiqueta nula ("+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+")");
			} else {
				System.out.println("Calendario.ponerDiasNoLectivos - no encontrada fecha en calendario curso actual ("+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+")");
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin",true);
	}
	public void actualizarDiasNoLectivosClase(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> dias;
		Label etiquetaDia;
		dias=BBDD.consultarDiasNoLectivosClase(null);
		for (int i=0;i<dias.size();i++){
			//System.out.print("Calendario actualizarDiasNoLectivosClase Dia noLectivo Clase: "+Fecha.formaFecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))+" = "+dias.get(i).get(5)+".");
			int indice=fechas.indexOf(Fecha.formaFechaInt(Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4))));
			if (indice>=0) {
				etiquetaDia=etiquetas.get(indice);
				if (etiquetaDia!=null) {
					Calendar fecha=Fecha.fecha(dias.get(i).get(2),dias.get(i).get(3),dias.get(i).get(4));
					actualizarEtiquetaDia(fecha);
					//System.out.println("ok");
				} else System.out.println("Calendario.actualizarDiasNoLectivosClase - etiqueta nula ("+Fecha.formaFecha(dias.get(i).get(1),dias.get(i).get(2),dias.get(i).get(3))+")");
			} else {
				System.out.println("Calendario.actualizarDiasNoLectivosClase - no encontrada fecha en calendario curso actual ("+Fecha.formaFecha(dias.get(i).get(1),dias.get(i).get(2),dias.get(i).get(3))+")");
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin",true);
	}
}
