/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Locale;
import java.util.Vector;

public class Fecha {
	private static Vector<Integer> noLaboralesCompletos = new Vector<Integer>();
	private static Vector<Integer> noLaboralesClase = new Vector<Integer>();
	public static final int MesesLectivosCalendario=10;
	public static final int MesInicioCalendario=Calendar.SEPTEMBER;
	public static final int MesesPorFilaCalendario=5;
	public static final int NDiasSemana=Calendar.getInstance().getActualMaximum(Calendar.DAY_OF_WEEK);
	public static final int NDiasSemanaFestivos=2;
	public static final int NDiasSemanaLaborales=Fecha.NDiasSemana-Fecha.NDiasSemanaFestivos;
	public static final int PrimerDiaSemanaLaboral=Calendar.MONDAY % NDiasSemana;
	public static final int PrimerDiaSemanaFestivo=Calendar.SATURDAY % NDiasSemana;
	public static final Vector<Integer> DiasSemanaFestivos= new Vector<Integer>();
	public static final char SeparadorFecha='-';
	public static final char SeparadorHora=':';
	public static final int laboralPrimera=8;
	public static final int laboralUltima=22;
	public static Calendar fechaDeTrabajo;
	public static Calendar inicioCurso;
	public static Calendar finCurso;
	public static boolean diaSemanaFestivo(int dia){
		boolean resultado=false;
		if (DiasSemanaFestivos.indexOf(dia)>=0) resultado=true;
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+dia+") "+resultado);
		return resultado;
	}
	public static int formaFechaInt(Calendar f){
		int resultado=-1;
		if (f!=null) resultado=Integer.parseInt(f.get(Calendar.YEAR)+String.format("%02d",f.get(Calendar.MONTH)+1)+String.format("%02d",f.get(Calendar.DAY_OF_MONTH)));
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+") "+resultado);;
		return resultado;
	}
	public static Calendar formaIntFecha(int entero){
		Calendar resultado=null;
		String fecha = String.valueOf(entero); // La función fecha ya resta 1 al mes
		if (fecha!=null) if (fecha.length()>=8) resultado = Fecha.fechaHoraCero(fecha(fecha.substring(6),fecha.substring(4,6),fecha.substring(0,4)));
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+entero+") fecha ("+fecha+") "+resultado);;
		return resultado;
	}
	public static Calendar fechaHoraCero(Calendar fecha){
		Calendar resultado=null;
		if (fecha!=null) {
			Calendar fechaSoloDia = Calendar.getInstance();
			fechaSoloDia.set(Calendar.DAY_OF_MONTH,fecha.get(Calendar.DAY_OF_MONTH));
			fechaSoloDia.set(Calendar.MONTH, fecha.get(Calendar.MONTH));
			fechaSoloDia.set(Calendar.YEAR, fecha.get(Calendar.YEAR));
			fechaSoloDia.set(Calendar.HOUR_OF_DAY, 0);
			fechaSoloDia.set(Calendar.MINUTE, 0);
			fechaSoloDia.set(Calendar.SECOND, 0);
			fechaSoloDia.set(Calendar.MILLISECOND, 0);
			resultado=fechaSoloDia;
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((fecha!=null)?Fecha.formaFechaDiaHora(fecha):"null")+") "+((resultado!=null)?Fecha.formaFechaDiaHora(resultado):"null"));;
		return resultado;
	}
	public static Calendar fechaHora(String d, String me, String a,String h, String mi){
		Calendar resultado=null;
		if (d!=null && me!=null && a!=null && h!=null && mi!=null) 
			if (!d.equals("") && !me.equals("") && !a.equals("") && !h.equals("") && !mi.equals("")) {
				Calendar fecha=Calendar.getInstance();
				fecha.set(Calendar.DAY_OF_MONTH, Integer.parseInt(d));
				fecha.set(Calendar.MONTH, Integer.parseInt(me)-1);
				fecha.set(Calendar.YEAR, Integer.parseInt(a));
				fecha.set(Calendar.HOUR_OF_DAY, Integer.parseInt(h));
				fecha.set(Calendar.MINUTE, Integer.parseInt(mi));
				fecha.set(Calendar.SECOND, 0);
				fecha.set(Calendar.MILLISECOND, 0);
				resultado=fecha;
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+d+","+me+","+a+","+h+","+mi+") "+((resultado!=null)?Fecha.formaFechaDiaHora(resultado):"null"));
		return resultado;
	}
	public static Calendar fecha(String d, String me, String a){
		Calendar resultado=null;
		if (d!=null && me!=null && a!=null) 
			if (!d.equals("") && !me.equals("") && !a.equals("")) {
				Calendar fecha=Calendar.getInstance();
				fecha.set(Calendar.DAY_OF_MONTH, Integer.parseInt(d));
				fecha.set(Calendar.MONTH, Integer.parseInt(me)-1);
				fecha.set(Calendar.YEAR, Integer.parseInt(a));
				fecha.set(Calendar.HOUR_OF_DAY, 0);
				fecha.set(Calendar.MINUTE, 0);
				fecha.set(Calendar.SECOND, 0);
				fecha.set(Calendar.MILLISECOND, 0);
				resultado=fecha;
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+d+","+me+","+a+") "+((resultado!=null)?Fecha.formaFechaDiaHora(resultado):"null"));
		return resultado;
	}
	public static Calendar hora(int h, int mi){
		Calendar resultado=null;
		if (h>=0 && h<=23 && mi>=0 && mi<=59) {
			Calendar fecha=Calendar.getInstance();
			fecha.set(Calendar.HOUR_OF_DAY, h);
			fecha.set(Calendar.MINUTE, mi);
			fecha.set(Calendar.YEAR, 0);
			fecha.set(Calendar.MONTH, 0);
			fecha.set(Calendar.DAY_OF_MONTH, 0);
			fecha.set(Calendar.SECOND, 0);
			fecha.set(Calendar.MILLISECOND, 0);
			resultado=fecha;
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+h+","+mi+") "+((resultado!=null)?Fecha.formaFechaDiaHora(resultado):"null"));
		return resultado;
	}
	public static Calendar hora(String h, String mi){
		Calendar resultado=null;
		if (h!=null && mi!=null)
			if (!h.equals("") && !mi.equals("")) {
				resultado=Fecha.hora(Integer.parseInt(h),Integer.parseInt(mi));
			}
		//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+h+","+mi+") "+((resultado!=null)?Fecha.formaFechaDiaHora(resultado):"null"));
		return resultado;
	}
	public static String formaHora(String h, String m){
		String resultado=null;
		if (h!=null && m!=null)
			if (!h.equals("") && !m.equals("")) {
				resultado=String.format("%02d",Integer.parseInt(h)) +Fecha.SeparadorHora+ String.format("%02d",Integer.parseInt(m));
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+h+","+m+") "+resultado);
		return resultado;
	}
	public static String formaUHoraria(String hi, String mi, String hf, String mf){
		String resultado=null;
		if (hi!=null && mi!=null && hf!=null && mf!=null) 
			if (!hi.equals("") && !mi.equals("") && !hf.equals("") && !mf.equals("")) {
				resultado=String.format("%02d",Integer.parseInt(hi)) +Fecha.SeparadorHora+ String.format("%02d",Integer.parseInt(mi)) 
						+"-"+ String.format("%02d",Integer.parseInt(hf)) +Fecha.SeparadorHora+ String.format("%02d",Integer.parseInt(mf));
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+hi+","+mi+","+hf+","+mf+") "+resultado);
		return resultado;
	}
	public static String formaFecha(String d, String m, String a){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+d+","+m+","+a+")");
		String resultado=null;
		if (d!=null && m!=null && a!=null)
			if (!d.equals("") && !m.equals("") && !a.equals("")) {
				Calendar fecha=Calendar.getInstance();
				fecha.set(Calendar.DAY_OF_MONTH, Integer.parseInt(d));
				fecha.set(Calendar.MONTH, Integer.parseInt(m)-1);
				fecha.set(Calendar.YEAR, Integer.parseInt(a));
				resultado=formaFecha(fecha);
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+d+","+m+","+a+") "+resultado);
		return resultado;
	}
	public static String formaFechaDia(String d, String m, String a){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+d+","+m+","+a+")");
		String resultado=null;
		if (d!=null && m!=null && a!=null)
			if (!d.equals("") && !m.equals("") && !a.equals("")) {
				Calendar fecha=Calendar.getInstance();
				fecha.set(Calendar.DAY_OF_MONTH, Integer.parseInt(d));
				fecha.set(Calendar.MONTH, Integer.parseInt(m)-1);
				fecha.set(Calendar.YEAR, Integer.parseInt(a));
				resultado=formaFechaDia(fecha);
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+d+","+m+","+a+") "+resultado);
		return resultado;
	}
	public static String formaFecha(Calendar f){
		String resultado=null;
		if (f!=null) {
			resultado=String.format("%02d",f.get(Calendar.DAY_OF_MONTH)) +Fecha.SeparadorFecha+
			String.format("%02d",f.get(Calendar.MONTH)+1) +Fecha.SeparadorFecha+
			f.get(Calendar.YEAR);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+") "+resultado);
		return resultado;
	}
	public static String nomArchivoFecha(Calendar f){
		String resultado=null;
		if (f!=null) {
			resultado=f.get(Calendar.YEAR)+String.format("%02d",f.get(Calendar.MONTH)+1)+
			String.format("%02d",f.get(Calendar.DAY_OF_MONTH));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+") "+resultado);
		return resultado;
	}
	public static String bbddSoloDia(Calendar f){
		String resultado=null;
		if (f!=null) {
			resultado=f.get(Calendar.YEAR)+"-"+String.format("%02d",f.get(Calendar.MONTH)+1)+
					"-"+String.format("%02d",f.get(Calendar.DAY_OF_MONTH));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+") "+resultado);
		return resultado;
	}
	public static String bbddSoloHora(Calendar f){
		String resultado=null;
		if (f!=null) {
			resultado=String.format("%02d",f.get(Calendar.HOUR_OF_DAY))+":"+String.format("%02d",f.get(Calendar.MINUTE))+
					":"+String.format("%02d",f.get(Calendar.SECOND));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+") "+resultado);
		return resultado;
	}
	public static String formaFechaDia(Calendar f){
		String resultado=null;
		if (f!=null) {
			resultado=f.getDisplayName(Calendar.DAY_OF_WEEK, Calendar.SHORT,Locale.getDefault()) +" "+
					String.format("%02d",f.get(Calendar.DAY_OF_MONTH)) +Fecha.SeparadorFecha+ 
					f.getDisplayName(Calendar.MONTH,Calendar.SHORT,Locale.getDefault()) +Fecha.SeparadorFecha+ 
					f.get(Calendar.YEAR);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+") "+resultado);
		return resultado;
	}
	public static String formaFechaDiaHora(Calendar f){
		String resultado=null;
		if (f!=null) {
			resultado=((f!=null)?f.getDisplayName(Calendar.DAY_OF_WEEK, Calendar.SHORT,Locale.getDefault()) +" "+ 
					String.format("%02d",f.get(Calendar.DAY_OF_MONTH)) +Fecha.SeparadorFecha+ 
					f.getDisplayName(Calendar.MONTH,Calendar.SHORT,Locale.getDefault()) +Fecha.SeparadorFecha+ 
					f.get(Calendar.YEAR) +" "+ String.format("%02d",f.get(Calendar.HOUR_OF_DAY)) +Fecha.SeparadorHora+
					String.format("%02d",f.get(Calendar.MINUTE)):null);
		}
		return resultado;
	}
	public static boolean diaNoLaboral(Calendar f, boolean paraClase) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+")");
		boolean resultado=false;
		if (f!=null) {
			Integer nL = Fecha.formaFechaInt(f);
			//for (int i=0;i<noLaboralesCompletos.size();i++) System.out.print(noLaboralesCompletos.get(i)+",");System.out.println("");
			//for (int i=0;i<noLaboralesClase.size();i++) System.out.print(noLaboralesClase.get(i)+",");System.out.println("");
			if (noLaboralesCompletos.indexOf(nL)>=0) resultado=true;
			else if (paraClase) if (noLaboralesClase.indexOf(nL)>=0) resultado=true;
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+") "+resultado);
		return resultado;
	}
	public static boolean diaLaboral(Calendar f,boolean paraClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+")");
		boolean resultado = true;
		if (f!=null) {
			if (Fecha.diaSemanaFestivo(f.get(Calendar.DAY_OF_WEEK))) resultado=false;
			else if (Fecha.diaNoLaboral(f,paraClase)) resultado=false;
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+") "+resultado);
		return resultado;
	}
	public static Calendar diaLaboralOSiguiente(Calendar f,boolean paraClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+")");
		Calendar fs = null;
		if (f!=null) {
			fs = (Calendar) f.clone();
			while (!Fecha.diaLaboral(fs,paraClase)) {fs.add(Calendar.DAY_OF_MONTH, +1);fs=Fecha.fechaHoraCero(fs);}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+") "+((fs!=null)?Fecha.formaFechaDiaHora(fs):"null"));
		return fs;
	}
	public static Calendar diaLaboralOAnterior(Calendar f,boolean paraClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+")");
		Calendar fs = null;
		if (f!=null) {
			fs = (Calendar) f.clone();
			while (!Fecha.diaLaboral(fs,paraClase)) {fs=Fecha.fechaHoraCero(fs);fs.add(Calendar.MINUTE, -1);}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+") "+((fs!=null)?Fecha.formaFechaDiaHora(fs):"null"));
		return fs;
	}
	public static boolean fechaHoraLaboral(Calendar f,boolean paraClase){ 
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+")");
		boolean resultado = (Fecha.diaLaboral(f,paraClase) && BBDD.consultarIdMateriaClaseParaFechaHora(f)!=null); 
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraClase+") "+resultado);
		return resultado;
	}
	public static Calendar getFechaHoraLaboralOSiguiente(Calendar f, boolean paraMateriaClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraMateriaClase+")");
		Calendar fs = null;
		boolean horarioVacio=BBDD.consultarUHvacio(null);
		if (f!=null) {
			fs = (Calendar) f.clone();
			String idGrupoMateriaFechaHora;
			//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Fecha getFechaHoraLaboralOSiguiente ("+Fecha.formaFechaDiaHora(fs)+", "+MateriaClase.getIdMateriaClaseDeTrabajo()+")");
			for (int i=0;i<30;i++) {
				//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("    i("+String.format("%02d",i)+") ("+Fecha.formaFechaDiaHora(fs)+")");
				if (Fecha.diaLaboral(fs,paraMateriaClase)) {
					if (horarioVacio) {
						//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Si ParaCualquierMateria.");
						break;
					} else {
						idGrupoMateriaFechaHora=BBDD.consultarIdMateriaClaseParaFechaHora(fs);
						//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("    Laboral idGrupoMateria "+idGrupoMateriaFechaHora);
						if (idGrupoMateriaFechaHora==null) {
							//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("    idGrupoMateriaFechaHora == nulll, busca siguiente en dia.");
							Calendar fhs=BBDD.consultarHoraSiguienteParaFechaMateriaClase(fs, 
									((paraMateriaClase)?MateriaClase.getIdMateriaClaseDeTrabajo():null));
							if (fhs!=null) {
								//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Si DesdeNull ("+Fecha.formaFechaDiaHora(fhs)+")");
								fs=fhs;break;
							}
						} else {
							//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("    idGrupoMateriaFechaHora == "+idGrupoMateriaFechaHora+", busca siguiente en dia.");
							if (!paraMateriaClase || idGrupoMateriaFechaHora.equals(MateriaClase.getIdMateriaClaseDeTrabajo())) {
								//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Si Materia == "+idGrupoMateria+".");
								break;
							} else {
								Calendar fhs=BBDD.consultarHoraSiguienteParaFechaMateriaClase(fs, MateriaClase.getIdMateriaClaseDeTrabajo());
								if (fhs!=null) {
									//if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Si DesdeOtra ("+Fecha.formaFechaDiaHora(fhs)+")");
									fs=fhs;break;
								}
							}
						}
					}
				}
				fs.add(Calendar.DAY_OF_MONTH, 1);
				if (i==0)fs=Fecha.fechaHoraCero(fs);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((f!=null)?Fecha.formaFechaDiaHora(f):"null")+","+paraMateriaClase+") "+((fs!=null)?Fecha.formaFechaDiaHora(fs):"null"));
		return fs;
	}
	public static void inicializar(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		Fecha.DiasSemanaFestivos.add(Calendar.SATURDAY); // dias de la seman no laborales
		Fecha.DiasSemanaFestivos.add(Calendar.SUNDAY);
		Fecha.fechaDeTrabajo=Calendar.getInstance();
		Fecha.actualizarDiasNoLectivosCompletos();
		Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente(Fecha.fechaDeTrabajo,false);
		Fecha.actualizarCurso();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("FechaDeTrabajo = "+((Fecha.fechaDeTrabajo!=null)?Fecha.formaFechaDiaHora(Fecha.fechaDeTrabajo):"null")+".");
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Curso = "+Fecha.formaFechaDiaHora(Fecha.inicioCurso)+" - "+Fecha.formaFechaDiaHora(Fecha.finCurso)+".");
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin");
	}
	public static void actualizarCurso(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		Fecha.inicioCurso=Fecha.fechaHoraCero(Fecha.fechaDeTrabajo);
		if (Fecha.inicioCurso.get(Calendar.MONTH)<Fecha.MesInicioCalendario ) Fecha.inicioCurso.add(Calendar.YEAR, -1);
		Fecha.inicioCurso.set(Calendar.MONTH, Fecha.MesInicioCalendario);
		Fecha.inicioCurso.set(Calendar.DAY_OF_MONTH, Calendar.getInstance().getActualMinimum(Calendar.DAY_OF_MONTH));
		Fecha.inicioCurso=Fecha.diaLaboralOSiguiente(Fecha.inicioCurso,false);
		Fecha.finCurso=(Calendar)Fecha.inicioCurso.clone();
		Fecha.finCurso.add(Calendar.MONTH, Fecha.MesesLectivosCalendario);
		Fecha.finCurso.add(Calendar.MINUTE, -1);
		Fecha.finCurso=Fecha.diaLaboralOAnterior(Fecha.finCurso,false);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+((Fecha.inicioCurso!=null)?Fecha.formaFechaDiaHora(Fecha.inicioCurso):"null")+" - "+((Fecha.finCurso!=null)?Fecha.formaFechaDiaHora(Fecha.finCurso):"null"));
	}
	public static void actualizarDiasNoLectivosCompletos(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Vector<Vector<String>> fs = BBDD.consultarDiasNoLectivosDiaCompletoYClase(null);
		Fecha.noLaboralesCompletos.removeAllElements();
		for (int i=0;i<fs.size();i++){
			Fecha.noLaboralesCompletos.add(Fecha.formaFechaInt(Fecha.fecha(fs.get(i).get(2),
					fs.get(i).get(3),fs.get(i).get(4))));
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+Fecha.noLaboralesCompletos.size()+" dias.",true);
	}
	public static void actualizarDiasNoLectivosClase(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		Fecha.noLaboralesClase.removeAllElements();
		Vector<Vector<String>> fs = BBDD.consultarDiasNoLectivosClase(MateriaClase.getIdClaseDeTrabajo());
		if (fs!=null)
			for (int i=0;i<fs.size();i++){
				Fecha.noLaboralesClase.add(Fecha.formaFechaInt(Fecha.fecha(fs.get(i).get(2),
					fs.get(i).get(3),fs.get(i).get(4))));
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+Fecha.noLaboralesCompletos.size()+" dias.",true);
	}
}
