/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;
import org.eclipse.swt.widgets.Combo;


public class FechaCombo {
	private Combo objetoCombo;
	private Vector<Calendar> fechas = new Vector<Calendar>();
	private Integer ultimoLectivo=-1;
	private Calendar ultimoFechaInicio=null;
	private String ultimoIdMateria=null;
	private Integer ultimoParcial=null;
	
	public FechaCombo(Combo combo){this.objetoCombo=combo;}

	public void add(Calendar fecha, String texto){objetoCombo.add(texto);fechas.add((Calendar)fecha.clone());}
	public void deshabilitar(){this.objetoCombo.setEnabled(false);}
	public void habilitar(){this.objetoCombo.setEnabled(true);}
	public void seleccionarPrimera(){if (objetoCombo!=null) objetoCombo.select(0);}
	public void borrar(){this.objetoCombo.removeAll();	fechas.clear(); ultimoLectivo=-1;ultimoFechaInicio=null;ultimoIdMateria=null;}
	public Calendar fechaSeleccionada(){return ((this.objetoCombo.getSelectionIndex()>=0)?fechas.get(this.objetoCombo.getSelectionIndex()):null);}
	public void seleccionarFecha(Calendar fecha){
		fecha=Fecha.fechaHoraCero(fecha);
		if (fecha!=null) {
			int indUltFecha=fechas.size()-1;
			if (indUltFecha>=0) {
				if (indUltFecha==0) this.objetoCombo.select(0);
				else if (fecha.compareTo(fechas.get(0))<=0) this.objetoCombo.select(0);
				else if (fecha.compareTo(fechas.get(indUltFecha))>=0) this.objetoCombo.select(indUltFecha);
				else {
					for (int i=0;i<indUltFecha;i++) {
						//System.out.println("seleccionarFecha "+i+"/"+fechas.size()+": "+Fecha.formaFechaDiaHora(fechas.get(i))+" == "+Fecha.formaFechaDiaHora(fecha)+" : "+fecha.getTimeInMillis()+" == "+fechas.get(i).getTimeInMillis()+" <> "+fecha.compareTo(fechas.get(i)));
						if (fecha.compareTo(fechas.get(i))<=0) {this.objetoCombo.select(i);break;}
					}
				}
			}
		}
		if (this.objetoCombo.getSelectionIndex()<0 && this.objetoCombo.getItemCount()>0) this.objetoCombo.select(0);
	}
	public void rellenarDesdeFecha(Calendar fechaInicio){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((fechaInicio!=null)?Fecha.formaFechaDiaHora(fechaInicio):"null")+")",false);
		if (this.objetoCombo!=null && (ultimoLectivo!=0 || (
				(ultimoFechaInicio==null && fechaInicio!=null) ||
				(ultimoFechaInicio!=null && fechaInicio==null) ||
				(ultimoFechaInicio!=null && fechaInicio!=null && 
						!ultimoFechaInicio.equals(fechaInicio))))) {
			Calendar fechaAntigua = ((this.objetoCombo.getSelectionIndex()>=0)?(Calendar)this.fechas.get(this.objetoCombo.getSelectionIndex()).clone():null);
			//System.out.println("Actualizando FechaCombo desdeFecha="+Fecha.formaFechaDiaHora(fechaInicio));
			ultimoLectivo=0;ultimoFechaInicio=((fechaInicio!=null)?(Calendar) fechaInicio.clone():null);
			this.objetoCombo.removeAll();
			fechas = new Vector<Calendar>();
			//Parcial.imprimirParciales();
			if (fechaInicio==null) fechaInicio=Fecha.inicioCurso;
			Calendar fechaFin=Fecha.finCurso;
			//System.out.println("Añadiendo fechasCombo inicio "+Fecha.formaFechaDia(fechaInicio)+" Fin "+Fecha.formaFechaDia(fechaFin));
			for (Calendar fecha = Fecha.fechaHoraCero(fechaInicio);	fecha.compareTo(fechaFin)<=0; fecha.add(Calendar.DAY_OF_MONTH, +1)){
				this.add(fecha,Fecha.formaFechaDia(fecha));
				//System.out.println("Añadiendo Sin Materia "+Fecha.formaFechaDia(fecha));
			}
			this.seleccionarFecha(fechaAntigua);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((fechaInicio!=null)?Fecha.formaFechaDiaHora(fechaInicio):"null")+")"+
				((this.objetoCombo!=null)?this.objetoCombo.getItemCount()+" elementos":"null"),true);
	}
	public void rellenarLectivosDesdeHastaFecha(Calendar desde,Calendar hasta,boolean paraClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((desde!=null)?Fecha.formaFechaDiaHora(desde):"null")+","+((hasta!=null)?Fecha.formaFechaDiaHora(hasta):"null")+")",false);
		if (this.objetoCombo!=null) {
			this.borrar();
			for (Calendar fecha=(Calendar)desde.clone(); fecha.compareTo(hasta)<=0; fecha.add(Calendar.DAY_OF_MONTH, +1)){
				if (Fecha.diaLaboral(fecha, paraClase)) {
					this.add(fecha,Fecha.formaFechaDia(fecha));
					//System.out.println("rellena: "+Fecha.formaFechaDiaHora(fecha));
				}
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((desde!=null)?Fecha.formaFechaDiaHora(desde):"null")+","+((hasta!=null)?Fecha.formaFechaDiaHora(hasta):"null")+")"+
				((this.objetoCombo!=null)?this.objetoCombo.getItemCount()+" elementos":"null"),true);
	}
	public void rellenarLectivosYDiaConcreto(Calendar noLectivo){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((noLectivo!=null)?Fecha.formaFechaDiaHora(noLectivo):"null")+")",false);
		if (this.objetoCombo!=null) if (noLectivo!=null){
			this.borrar();
			Calendar fechaInicio,fechaFin;
			fechaInicio=Fecha.inicioCurso;
			fechaFin=Fecha.finCurso;
			//System.out.println("FechaCombo rellenarLectivosParcialYFestivo("+Fecha.formaFecha(noLectivo)+")");
			boolean insertado=false;
			for (Calendar fecha = Fecha.fechaHoraCero(fechaInicio);	fecha.compareTo(fechaFin)<=0; fecha.add(Calendar.DAY_OF_MONTH, +1)){
				//System.out.print("   Fecha "+Fecha.formaFechaDia(fecha));
				if (!Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
					if (fecha.compareTo(noLectivo)>=0 && !insertado) {
						this.add(noLectivo,Fecha.formaFechaDia(noLectivo));
						//System.out.println(" Insertando."+Fecha.formaFechaDia(noLectivo));
						insertado=true;
						if (fecha.compareTo(noLectivo)>0) {
							this.add(fecha,Fecha.formaFechaDia(fecha));
							//System.out.println(" Insertando."+Fecha.formaFechaDia(fecha));
						}
					} else {
						if (Fecha.diaLaboral(fecha,false)) {
							this.add(fecha,Fecha.formaFechaDia(fecha));
							//System.out.println(" Insertando."+Fecha.formaFechaDia(fecha));
						}
					}
				}
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+((noLectivo!=null)?Fecha.formaFechaDiaHora(noLectivo):"null")+")"+
				((this.objetoCombo!=null)?this.objetoCombo.getItemCount()+" elementos":"null"),true);
	}
	public void rellenarLectivosParcialDesdeFechaMateria(Integer nParcial,Calendar fechaInicio,boolean paraMateriaClase){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+nParcial+","+((fechaInicio!=null)?Fecha.formaFechaDiaHora(fechaInicio):"null")+","+paraMateriaClase+")",false);
		// si Parcial = null todos,si fechaInicio=null => inicio curso y si idMateria=null todos los días lectivos
		//System.out.println("Inicio "+((fechaInicio!=null)?Fecha.formaFechaDia(fechaInicio):"null"));
		if (this.objetoCombo!=null && (ultimoLectivo!=1 || (
				(
						(ultimoFechaInicio==null && fechaInicio!=null) || 
						(ultimoFechaInicio!=null && fechaInicio==null) ||
						(ultimoFechaInicio!=null && fechaInicio!=null && !ultimoFechaInicio.equals(fechaInicio))
				)||(
						(ultimoIdMateria==null && paraMateriaClase) || 
						(ultimoIdMateria!=null && !paraMateriaClase) ||
						(ultimoIdMateria!=null && paraMateriaClase && !ultimoIdMateria.equals(MateriaClase.getIdMateriaClaseDeTrabajo()))
				)||(
						(ultimoParcial==null && nParcial!=null) || 
						(ultimoParcial!=null && nParcial==null) ||
						(ultimoParcial!=null && nParcial!=null && !ultimoParcial.equals(nParcial))
				)))) {
			Calendar fechaAntigua = ((this.objetoCombo.getSelectionIndex()>=0)?(Calendar)this.fechas.get(this.objetoCombo.getSelectionIndex()).clone():null);
			//System.out.println(" Actualizando FechaCombo Parcial="+nParcial+" desdeFecha="+Fecha.formaFechaDiaHora(fechaInicio)+" materia="+idMateria);
			ultimoLectivo=1;
			ultimoFechaInicio=((fechaInicio!=null)?(Calendar) fechaInicio.clone():null);
			ultimoIdMateria=MateriaClase.getIdMateriaClaseDeTrabajo();
			this.objetoCombo.removeAll();
			fechas.clear();
			if (fechaInicio==null) {
				if (nParcial!=null) fechaInicio=Parcial.getFechaInicioParcial(nParcial);
				if (fechaInicio==null) fechaInicio=Fecha.inicioCurso;
			}
			Calendar fechaFin=((nParcial!=null)?Parcial.getFechaFinParcial(nParcial):null);
			if (fechaFin==null) fechaFin=Fecha.finCurso;
			//System.out.println("  Actualizando FechaCombo Parcial="+nParcial+" desdeFecha="+Fecha.formaFechaDiaHora(fechaInicio)+" materia="+idMateria);
			//System.out.println("  Inicio "+Fecha.formaFechaDia(fechaInicio)+" Fin "+Fecha.formaFechaDia(fechaFin));
			//System.out.println("  Parcial= "+Parcial.getParcial(Fecha.fechaDeTrabajo)+", Materia= "+MateriaClase.getIdMateriaDeTrabajo());
			Vector<Integer> dias=null;
			if (paraMateriaClase) dias=BBDD.consultarDiasSemanaMateriaClase(MateriaClase.getIdMateriaClaseDeTrabajo());
			for (Calendar fecha = Fecha.fechaHoraCero(fechaInicio);	fecha.compareTo(fechaFin)<=0; fecha.add(Calendar.DAY_OF_MONTH, +1)){
				//System.out.print("   Fecha "+Fecha.formaFechaDia(fecha));
				if (paraMateriaClase){
					if (Fecha.diaLaboral(fecha,true)){
						boolean diaDaMateria=false;
						for (int j=0;j<dias.size();j++) 
							if (dias.get(j)==Integer.valueOf(fecha.get(Calendar.DAY_OF_WEEK))) {diaDaMateria=true;break;}
						if (diaDaMateria) {
							this.add(fecha,Fecha.formaFechaDia(fecha));
							//System.out.println("Añadiendo ("+idMateria+") "+Fecha.formaFechaDiaHora(fecha));
						} else {
							//System.out.println("No Añadiendo ("+idMateria+") "+Fecha.formaFechaDiaHora(fecha));
						}
					}
				} else {
					if (Fecha.diaLaboral(fecha,false)){
						if (!Fecha.diaSemanaFestivo(fecha.get(Calendar.DAY_OF_WEEK))) {
							this.add(fecha,Fecha.formaFechaDia(fecha));
							//System.out.println("Añadiendo "+Fecha.formaFechaDiaHora(fecha));
						}
					}
				}
			}
			if (fechaAntigua!=null) this.seleccionarFecha(fechaAntigua); else this.objetoCombo.select(0);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+nParcial+","+
				((fechaInicio!=null)?Fecha.formaFechaDiaHora(fechaInicio):"null")+
				","+paraMateriaClase+") "+((this.objetoCombo!=null)?this.objetoCombo.getItemCount():"null")+
				" registros",true);
	}
}

