/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.List;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Text;

public class Mantenimiento extends Composite {
	private Text txtDiaNoLectivoDescripcion;public Text getTxtDiaNoLectivoDescripcion(){return txtDiaNoLectivoDescripcion;}
	private Combo comboDiaNoLectivoFecha;
	private List listDiasNoLectivos;
	private ListConId listConIdDiasNoLectivos;
	private Button btnDiaNoLectivoBorrar;
	private Button btnDiaNoLectivoNuevo;
	private FechaCombo fechaComboDiaNoLectivoFecha;
	private Text txtTiposEvaluablesReferencia;public Text getTxtTiposEvaluablesReferencia(){return txtTiposEvaluablesReferencia;}
	private Text txtTiposEvaluablesPeso;public Text getTxtTiposEvaluablesPeso(){return txtTiposEvaluablesPeso;}
	private Text txtTiposEvaluablesMinimo;public Text getTxtTiposEvaluablesMinimo(){return txtTiposEvaluablesMinimo;}
	private Text txtTiposEvaluablesDescripcion;public Text getTxtTiposEvaluablesDescripcion(){return txtTiposEvaluablesDescripcion;}
	private Combo comboTiposEvaluablesGrupoMateria;
	private List listTiposEvaluables;
	private Button btnTiposEvaluablesNuevo;
	private Button btnTiposEvaluablesBorrar;
	private ListConId listConIdTiposEvaluables;
	private ComboConId comboConIdTiposEvaluablesMateria;
	private Text txtProfesorNombre;public Text getTxtProfesorNombre(){return txtProfesorNombre;}
	private Text txtProfesorApellidos;public Text getTxtProfesorApellidos(){return txtProfesorApellidos;}
	private Text txtProfesorDatos;public Text getTxtProfesorDatos(){return txtProfesorDatos;}
	private Button btnParcialNuevo;
	private Button btnParcialBorrar;
	private Button btnProfesorNuevo;
	private Button btnProfesorBorrar;
	private ComboConId comboConIdDiaNoLectivoClase;
	private ListConId listConIdProfesores;
	private Button btnProfesorClave;
	private ComboConId comboConIdParcialesMateria;
	private ListConId listConIdParciales;
	private FechaCombo fechaComboParcialInicio;
	private FechaCombo fechaComboParcialFin;
	public Mantenimiento(Composite parent, int style) {super(parent, style);initialize();}
	public void actualizar(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		comboConIdTiposEvaluablesMateria.rellenarMaterias(true);
		actualizarTiposEvaluablesLista(null);
		comboConIdDiaNoLectivoClase.rellenarClases(null,BBDD.idDiaCompleto,BBDD.expDiaCompleto);
		actualizarDiasNoLectivosLista(null);
		actualizarProfesoresLista(null);
		comboConIdParcialesMateria.rellenarMaterias(false);
		comboConIdParcialesMateria.seleccionarId(MateriaClase.getIdMateriaDeTrabajo());
		actualizarParcialesLista(null);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() fin");
	}

	private void initialize() {
		GridLayout gridLayoutMantener = new GridLayout();
		gridLayoutMantener.numColumns = 3;
		gridLayoutMantener.horizontalSpacing = 2;
		gridLayoutMantener.verticalSpacing = 2;
		gridLayoutMantener.marginWidth = 2;
		gridLayoutMantener.marginHeight = 2;
		GridData gridDataMantener = new GridData();
		gridDataMantener.grabExcessHorizontalSpace = true;
		gridDataMantener.grabExcessVerticalSpace = true;
		gridDataMantener.horizontalAlignment = GridData.FILL;
		gridDataMantener.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataMantener);
		this.setLayout(gridLayoutMantener);
		this.setSize(new Point(685, 340));
		
		//+++++++++++++++++++++++++++++Tipos de Evaluables
		
		Group grpTiposDeEvaluables = new Group(this, SWT.NONE);
		GridData gd_grpTiposDeEvaluables = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grpTiposDeEvaluables.widthHint = 200;
		gd_grpTiposDeEvaluables.heightHint = 150;
		grpTiposDeEvaluables.setLayoutData(gd_grpTiposDeEvaluables);
		grpTiposDeEvaluables.setText("Tipos de ítem Evaluable:");
		GridLayout gl_grpTiposDeEvaluables = new GridLayout(6, false);
		gl_grpTiposDeEvaluables.horizontalSpacing = 2;
		gl_grpTiposDeEvaluables.marginHeight = 2;
		gl_grpTiposDeEvaluables.marginWidth = 2;
		gl_grpTiposDeEvaluables.verticalSpacing = 2;
		grpTiposDeEvaluables.setLayout(gl_grpTiposDeEvaluables);
		
		Label lblTiposEvaluablesGrupo = new Label(grpTiposDeEvaluables, SWT.NONE);
		lblTiposEvaluablesGrupo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 2, 1));
		lblTiposEvaluablesGrupo.setText("Materia:");
		
		comboTiposEvaluablesGrupoMateria = new Combo(grpTiposDeEvaluables,SWT.READ_ONLY);
		comboTiposEvaluablesGrupoMateria.setToolTipText("Elige la materia en la que estará definido el tipo de ítem evaluable.");
		comboTiposEvaluablesGrupoMateria.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboTiposEvaluablesGrupoMateria");
				actualizarTiposEvaluablesLista(null);
			}
		});
		comboTiposEvaluablesGrupoMateria.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 4, 1));
		comboConIdTiposEvaluablesMateria=new ComboConId(comboTiposEvaluablesGrupoMateria);
		
		listTiposEvaluables = new List(grpTiposDeEvaluables, SWT.BORDER | SWT.V_SCROLL);
		listTiposEvaluables.setToolTipText("Los tipos ítem definidos para la materia seleccionada. Por ejemplo: Trb - trabajos, Eje - Ejercicios, Exm - Examenes, etc.");
		listTiposEvaluables.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listTiposEvaluables "+listConIdTiposEvaluables.idSeleccionado());
				actualizarTiposEvaluablesDatos();
			}
		});
		GridData gd_listTiposEvaluables = new GridData(SWT.FILL, SWT.FILL, true, true, 4, 2);
		gd_listTiposEvaluables.widthHint = 40;
		gd_listTiposEvaluables.heightHint = 25;
		gd_listTiposEvaluables.minimumWidth = 100;
		gd_listTiposEvaluables.minimumHeight = 25;
		listTiposEvaluables.setLayoutData(gd_listTiposEvaluables);
		listConIdTiposEvaluables=new ListConId(listTiposEvaluables);
		
		Composite comositeTiposEvaluablesNuevoBorrar = new Composite(grpTiposDeEvaluables, SWT.NONE);
		comositeTiposEvaluablesNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 2, 1));
		GridLayout gl_comositeTiposEvaluablesNuevoBorrar = new GridLayout(2, false);
		gl_comositeTiposEvaluablesNuevoBorrar.verticalSpacing = 2;
		gl_comositeTiposEvaluablesNuevoBorrar.marginWidth = 2;
		gl_comositeTiposEvaluablesNuevoBorrar.marginHeight = 2;
		gl_comositeTiposEvaluablesNuevoBorrar.horizontalSpacing = 2;
		comositeTiposEvaluablesNuevoBorrar.setLayout(gl_comositeTiposEvaluablesNuevoBorrar);
		
		btnTiposEvaluablesNuevo = new Button(comositeTiposEvaluablesNuevoBorrar, SWT.NONE);
		btnTiposEvaluablesNuevo.setToolTipText("Crear un nuevo tipo de ítem evaluable.");
		btnTiposEvaluablesNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnTiposEvaluablesNuevo");
				String idTipo = BBDD.insertarTipoEvaluable(comboConIdTiposEvaluablesMateria.idSeleccionado(),"Aaa","",1,"0");
				actualizarTiposEvaluablesLista(idTipo);
				txtTiposEvaluablesReferencia.setFocus();
				txtTiposEvaluablesReferencia.selectAll();
			}
		});
		btnTiposEvaluablesNuevo.setText("Nuevo");
		
		btnTiposEvaluablesBorrar = new Button(comositeTiposEvaluablesNuevoBorrar, SWT.NONE);
		btnTiposEvaluablesBorrar.setToolTipText("Borrar el tipo de ítem evaluable seleccionado. Borrará el tipo, todos los ítem evaluables de ese tipo y todas las evaluaciones de los ítem evaluables de ese tipo.");
		btnTiposEvaluablesBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnTiposEvaluablesBorrar");
				String m="Se borrará el tipo de item evaluable seleccionado, todos los item evaluables" +
						" de ese tipo y todas las evaluaciones de los item de este tipo. ¿Desea borrarla?";
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					BBDD.borrarTipoEvaluable(listConIdTiposEvaluables.idSeleccionado());
					listConIdTiposEvaluables.seleccionarSiguienteOAnterior();
					actualizarTiposEvaluablesLista(null);
				}
			}
		});
		btnTiposEvaluablesBorrar.setText("Borrar");
		
		Composite compositePeso = new Composite(grpTiposDeEvaluables, SWT.NONE);
		compositePeso.setLayoutData(new GridData(SWT.RIGHT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositePeso = new GridLayout(1, false);
		gl_compositePeso.verticalSpacing = 0;
		gl_compositePeso.marginWidth = 0;
		gl_compositePeso.marginHeight = 0;
		gl_compositePeso.horizontalSpacing = 0;
		compositePeso.setLayout(gl_compositePeso);
		
		Label lblTiposEvaluablesPeso = new Label(compositePeso, SWT.NONE);
		lblTiposEvaluablesPeso.setText("Peso:");
		
		txtTiposEvaluablesPeso = new Text(compositePeso, SWT.BORDER);
		txtTiposEvaluablesPeso.setToolTipText("Peso que tendrá el tipo de ítem respesto de los demás tipos.");
		txtTiposEvaluablesPeso.setText("000");
		TextoDemorado.add(txtTiposEvaluablesPeso,true,3,null,null,false,listConIdTiposEvaluables,null);
		
		Composite compositeMinimo = new Composite(grpTiposDeEvaluables, SWT.NONE);
		compositeMinimo.setLayoutData(new GridData(SWT.RIGHT, SWT.BOTTOM, false, true, 1, 1));
		GridLayout gl_compositeMinimo = new GridLayout(1, false);
		gl_compositeMinimo.verticalSpacing = 0;
		gl_compositeMinimo.marginWidth = 0;
		gl_compositeMinimo.marginHeight = 0;
		gl_compositeMinimo.horizontalSpacing = 0;
		compositeMinimo.setLayout(gl_compositeMinimo);
		
		Label lblTiposEvaluablesMinimo = new Label(compositeMinimo, SWT.NONE);
		lblTiposEvaluablesMinimo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblTiposEvaluablesMinimo.setText("Mínimo:");
		
		txtTiposEvaluablesMinimo = new Text(compositeMinimo, SWT.BORDER);
		txtTiposEvaluablesMinimo.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		txtTiposEvaluablesMinimo.setToolTipText("Será la calificación mínima que debe tener el estudiante para calcular el subtotal para este tipo de ítem evaluable.");
		txtTiposEvaluablesMinimo.setText("0.0");
		TextoDemorado.add(txtTiposEvaluablesMinimo,true,1,2,Numero.notaMax,false,listConIdTiposEvaluables,null);
		
		Label lblTiposEvaluablesReferencia = new Label(grpTiposDeEvaluables, SWT.NONE);
		lblTiposEvaluablesReferencia.setText("Ref.:");
		
		txtTiposEvaluablesReferencia = new Text(grpTiposDeEvaluables, SWT.BORDER);
		txtTiposEvaluablesReferencia.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 2, 1));
		txtTiposEvaluablesReferencia.setText("XXX");
		txtTiposEvaluablesReferencia.setToolTipText("Referencia del tipo de ítem evaluable.");
		TextoDemorado.add(txtTiposEvaluablesReferencia,false,3,null,null,false,listConIdTiposEvaluables,null);
		
		txtTiposEvaluablesDescripcion = new Text(grpTiposDeEvaluables, SWT.BORDER);
		txtTiposEvaluablesDescripcion.setToolTipText("Descripción larga del tipo de ítem evaluable");
		txtTiposEvaluablesDescripcion.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 3, 1));
		TextoDemorado.add(txtTiposEvaluablesDescripcion,false,256,null,null,true,listConIdTiposEvaluables,null);
		
		
		Group grpDiasNoLectivos = new Group(this, SWT.NONE);
		GridData gd_grpDiasNoLectivos = new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1);
		gd_grpDiasNoLectivos.widthHint = 300;
		gd_grpDiasNoLectivos.heightHint = 150;
		grpDiasNoLectivos.setLayoutData(gd_grpDiasNoLectivos);
		grpDiasNoLectivos.setText("Dias No Lectivos:");
		GridLayout gl_grpDiasNoLectivos = new GridLayout(2, false);
		gl_grpDiasNoLectivos.horizontalSpacing = 2;
		gl_grpDiasNoLectivos.verticalSpacing = 2;
		gl_grpDiasNoLectivos.marginWidth = 2;
		gl_grpDiasNoLectivos.marginHeight = 2;
		grpDiasNoLectivos.setLayout(gl_grpDiasNoLectivos);
		
		listDiasNoLectivos = new List(grpDiasNoLectivos, SWT.BORDER | SWT.V_SCROLL);
		listDiasNoLectivos.setToolTipText("Dias no lectivos. Por ejemplo: Semana Santa, Baja Resfriado, Excursión, etc.");
		listDiasNoLectivos.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listDiasNoLectivos "+listConIdDiasNoLectivos.idSeleccionado());
				actualizarDiaNoLectivoDatos();
			}
		});
		listDiasNoLectivos.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		listConIdDiasNoLectivos = new ListConId(listDiasNoLectivos);
		
		Composite compositeDiaNoLectivoNuevoBorrar = new Composite(grpDiasNoLectivos, SWT.NONE);
		compositeDiaNoLectivoNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false, 1, 1));
		GridLayout gl_compositeDiaNoLectivoNuevoBorrar = new GridLayout(1, false);
		gl_compositeDiaNoLectivoNuevoBorrar.horizontalSpacing = 2;
		gl_compositeDiaNoLectivoNuevoBorrar.marginHeight = 2;
		gl_compositeDiaNoLectivoNuevoBorrar.verticalSpacing = 2;
		gl_compositeDiaNoLectivoNuevoBorrar.marginWidth = 2;
		compositeDiaNoLectivoNuevoBorrar.setLayout(gl_compositeDiaNoLectivoNuevoBorrar);
		
		btnDiaNoLectivoNuevo = new Button(compositeDiaNoLectivoNuevoBorrar, SWT.NONE);
		btnDiaNoLectivoNuevo.setToolTipText("Crear un nuevo dia no lectivo.");
		btnDiaNoLectivoNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnDiaNoLectivoNuevo");
				String idNoLectivo = BBDD.insertarDiaNoLectivo(Fecha.diaLaboralOSiguiente(Fecha.fechaDeTrabajo,false),null, "");
				Fecha.actualizarDiasNoLectivosCompletos();
				actualizarDiasNoLectivosLista(idNoLectivo);
				txtDiaNoLectivoDescripcion.setFocus();
				PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboDiaNoLectivoFecha.fechaSeleccionada());
				PCuaderno.MiPCuaderno.programacion.actualizarPorImpartir();
				PCuaderno.MiPCuaderno.programacion.actualizarTerminaNodo();
			}
		});
		btnDiaNoLectivoNuevo.setText("Nuevo");
		
		btnDiaNoLectivoBorrar = new Button(compositeDiaNoLectivoNuevoBorrar, SWT.NONE);
		btnDiaNoLectivoBorrar.setToolTipText("Borrar el dia lectivo seleccionado.");
		btnDiaNoLectivoBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnDiaNoLectivoBorrar");
				String id = listConIdDiasNoLectivos.idSeleccionado();
				Vector<String> noLectivo = BBDD.consultarDiaNoLectivo(id);
				Calendar f = Fecha.fecha(noLectivo.get(2), noLectivo.get(3), noLectivo.get(4));
				BBDD.borrarDiaNoLectivo(id);
				PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(f);
				listConIdDiasNoLectivos.seleccionarSiguienteOAnterior();
				actualizarDiasNoLectivosLista(null);
				listConIdDiasNoLectivos.fijarFoco();
			}
		});
		btnDiaNoLectivoBorrar.setText("Borrar");
		
		Composite compositeDiasNoLectivosEstructural = new Composite(grpDiasNoLectivos, SWT.NONE);
		compositeDiasNoLectivosEstructural.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2, 1));
		GridLayout gl_compositeDiasNoLectivosEstructural = new GridLayout(4, false);
		gl_compositeDiasNoLectivosEstructural.marginWidth = 0;
		gl_compositeDiasNoLectivosEstructural.marginHeight = 0;
		compositeDiasNoLectivosEstructural.setLayout(gl_compositeDiasNoLectivosEstructural);
		
		Label lblDiaNoLectivoClase = new Label(compositeDiasNoLectivosEstructural, SWT.NONE);
		lblDiaNoLectivoClase.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDiaNoLectivoClase.setText("Clase:");
		
		Combo comboDiaNoLectivoClase = new Combo(compositeDiasNoLectivosEstructural, SWT.READ_ONLY);
		comboDiaNoLectivoClase.setToolTipText("Clase a la que afecta el dia no lectivo seleccionado. Por ejemplo: Festivo - Dia Completo, Excursión - 2ºA ESO, etc.");
		comboDiaNoLectivoClase.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboDiaNoLectivoClase "+comboConIdDiaNoLectivoClase.idSeleccionado());
				BBDD.modificarDiaNoLectivoClase(listConIdDiasNoLectivos.idSeleccionado(),comboConIdDiaNoLectivoClase.idSeleccionado());
				Fecha.actualizarDiasNoLectivosCompletos();
				Fecha.actualizarDiasNoLectivosClase();
				PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboDiaNoLectivoFecha.fechaSeleccionada());
				PCuaderno.MiPCuaderno.programacion.actualizarPorImpartir();
				PCuaderno.MiPCuaderno.programacion.actualizarTerminaNodo();
			}
		});
		GridData gd_lblDiaNoLectivoEstructural = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_lblDiaNoLectivoEstructural.widthHint = 75;
		comboDiaNoLectivoClase.setLayoutData(gd_lblDiaNoLectivoEstructural);
		comboConIdDiaNoLectivoClase = new ComboConId(comboDiaNoLectivoClase);
		
		Label lblDiaNoLectivoFecha = new Label(compositeDiasNoLectivosEstructural, SWT.HORIZONTAL);
		lblDiaNoLectivoFecha.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblDiaNoLectivoFecha.setText("Fecha:");
		
		comboDiaNoLectivoFecha = new Combo(compositeDiasNoLectivosEstructural,SWT.READ_ONLY);
		comboDiaNoLectivoFecha.setToolTipText("Fecha del día no lectivo seleccionado.");
		GridData gd_comboDiaNoLectivoFecha = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_comboDiaNoLectivoFecha.widthHint = 150;
		comboDiaNoLectivoFecha.setLayoutData(gd_comboDiaNoLectivoFecha);
		comboDiaNoLectivoFecha.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboDiaNoLectivoFecha "+Fecha.formaFechaDiaHora(fechaComboDiaNoLectivoFecha.fechaSeleccionada()));
				String idNoLectivo = listConIdDiasNoLectivos.idSeleccionado();
				Vector<String> antiguo = BBDD.consultarDiaNoLectivo(idNoLectivo);
				BBDD.modificarDiaNoLectivoFecha(idNoLectivo,fechaComboDiaNoLectivoFecha.fechaSeleccionada());
				if (comboConIdDiaNoLectivoClase.idSeleccionado()==null) {
					Fecha.actualizarDiasNoLectivosCompletos();
				} else {
					Fecha.actualizarDiasNoLectivosClase();
				}
				actualizarDiasNoLectivosLista(null);
				listConIdDiasNoLectivos.seleccionarId(idNoLectivo);
				Fecha.actualizarDiasNoLectivosCompletos();
				Fecha.actualizarDiasNoLectivosClase();
				PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(Fecha.fecha(antiguo.get(2),antiguo.get(3),antiguo.get(4)));
				PCuaderno.MiPCuaderno.calendario.actualizarEtiquetaDia(fechaComboDiaNoLectivoFecha.fechaSeleccionada());
				PCuaderno.MiPCuaderno.programacion.actualizarPorImpartir();
				PCuaderno.MiPCuaderno.programacion.actualizarTerminaNodo();
			}
		});
		fechaComboDiaNoLectivoFecha = new FechaCombo(comboDiaNoLectivoFecha);
		
		txtDiaNoLectivoDescripcion = new Text(grpDiasNoLectivos, SWT.BORDER);
		txtDiaNoLectivoDescripcion.setToolTipText("Descripción del dia no lectivo.");
		txtDiaNoLectivoDescripcion.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 2, 1));
		TextoDemorado.add(txtDiaNoLectivoDescripcion,false,256,null,null,true,listConIdDiasNoLectivos,null);
		
		//+++++++++++++++++++++++++++++Profesores
		
		Group grpProfesores = new Group(this, SWT.NONE);
		GridLayout gl_grpProfesores = new GridLayout(6, false);
		gl_grpProfesores.verticalSpacing = 2;
		gl_grpProfesores.marginWidth = 2;
		gl_grpProfesores.marginHeight = 2;
		gl_grpProfesores.horizontalSpacing = 2;
		grpProfesores.setLayout(gl_grpProfesores);
		GridData gd_grpProfesores = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grpProfesores.widthHint = 200;
		gd_grpProfesores.heightHint = 150;
		grpProfesores.setLayoutData(gd_grpProfesores);
		grpProfesores.setText("Profesores:");
		
		List listProfesores = new List(grpProfesores, SWT.BORDER | SWT.V_SCROLL);
		listProfesores.setToolTipText("Profesores definidos para el programa, como el usuario y los demás tutores de los grupos a las que le dámos clase.");
		GridData gd_list = new GridData(SWT.FILL, SWT.FILL, true, true, 5, 1);
		gd_list.minimumHeight = 25;
		gd_list.heightHint = 25;
		listProfesores.setLayoutData(gd_list);
		listConIdProfesores = new ListConId(listProfesores);
		listProfesores.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listProfesores "+listConIdProfesores.idSeleccionado());
				actualizarProfesorDatos();
			}
		});
		
		Composite compositeProfesoresNuevoBorrar = new Composite(grpProfesores, SWT.NONE);
		compositeProfesoresNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 1));
		GridLayout gl_compositeProfesoresNuevoBorrar = new GridLayout(1, false);
		gl_compositeProfesoresNuevoBorrar.horizontalSpacing = 2;
		gl_compositeProfesoresNuevoBorrar.marginHeight = 2;
		gl_compositeProfesoresNuevoBorrar.verticalSpacing = 2;
		gl_compositeProfesoresNuevoBorrar.marginWidth = 2;
		compositeProfesoresNuevoBorrar.setLayout(gl_compositeProfesoresNuevoBorrar);
		
		btnProfesorNuevo = new Button(compositeProfesoresNuevoBorrar, SWT.NONE);
		btnProfesorNuevo.setToolTipText("Crear un profesor nuevo.");
		btnProfesorNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnProfesoresNuevo");
				String idProfesor = BBDD.insertarProfesor("Nombre","Apellidos","");
				actualizarProfesoresLista(idProfesor);
				txtProfesorNombre.setFocus();
				txtProfesorNombre.selectAll();
			}
		});
		btnProfesorNuevo.setText("Nuevo");
		
		btnProfesorBorrar = new Button(compositeProfesoresNuevoBorrar, SWT.NONE);
		btnProfesorBorrar.setToolTipText("Borrar el profesor seleccionado.");
		btnProfesorBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnProfesoresNuevo");
				if (!listConIdProfesores.idSeleccionado().equals(BBDD.consultarIdPropio())) {
					String claseTutoria = BBDD.consultarIdClaseTutoria(listConIdProfesores.idSeleccionado());
					if (claseTutoria!=null) {
						Vector<Vector<String>> clase=BBDD.consultarClase(null, claseTutoria);
						PCuaderno.MiPCuaderno.informacion("El profesor "+clase.get(0).get(5)+" "+clase.get(0).get(6)+
								" es tutor de la clase "+clase.get(0).get(1)+"º"+clase.get(0).get(2)+" "+clase.get(0).get(3)+
								". Para poder ser borrado cambie el tutor de la clase antes." +
								" Un profesor que es tutor de alguna clase no puede ser borrado.");
					} else {
						String m="Se borrará el profesor. ¿Desea continuar?";
						int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
						if (buttonID == SWT.OK) {
							BBDD.borrarProfesor(listConIdProfesores.idSeleccionado());
							listConIdProfesores.seleccionarSiguienteOAnterior();
							actualizarProfesoresLista(null);
						}
						
					}
				} else {
					PCuaderno.MiPCuaderno.informacion("El profesor usuario no puede ser borrardo.");
				}
			}
		});
		btnProfesorBorrar.setText("Borrar");
		
		Label lblProfesorNombre = new Label(grpProfesores, SWT.NONE);
		lblProfesorNombre.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, false, 2, 1));
		lblProfesorNombre.setText("Nombre:");
		
		txtProfesorNombre = new Text(grpProfesores, SWT.BORDER);
		txtProfesorNombre.setToolTipText("Nombre del profesor seleccionado.");
		txtProfesorNombre.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		TextoDemorado.add(txtProfesorNombre,false,256,null,null,false,listConIdProfesores,null);
		
		Label labelProfesorComa = new Label(grpProfesores, SWT.NONE);
		labelProfesorComa.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		labelProfesorComa.setText(",");
		
		txtProfesorApellidos = new Text(grpProfesores, SWT.BORDER);
		txtProfesorApellidos.setToolTipText("Apellidos del profesor seleccionado.");
		GridData gd_textProfesorApellidos = new GridData(SWT.FILL, SWT.CENTER, false, false, 2, 1);
		gd_textProfesorApellidos.widthHint = 100;
		txtProfesorApellidos.setLayoutData(gd_textProfesorApellidos);
		TextoDemorado.add(txtProfesorApellidos,false,256,null,null,true,listConIdProfesores,null);
		
		Label lblProfesorDatos = new Label(grpProfesores, SWT.NONE);
		lblProfesorDatos.setText("Datos:");
		
		txtProfesorDatos = new Text(grpProfesores, SWT.BORDER);
		txtProfesorDatos.setToolTipText("Información del profesor seleccionado.");
		txtProfesorDatos.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 5, 1));
		TextoDemorado.add(txtProfesorDatos,false,256,null,null,true,listConIdProfesores,null);

		//+++++++++++++++++++++++++++++Parciales
		
		Group grpParciales = new Group(this, SWT.NONE);
		grpParciales.setText("Parciales:");
		GridLayout gl_grpParciales = new GridLayout(3, false);
		gl_grpParciales.verticalSpacing = 2;
		gl_grpParciales.marginWidth = 2;
		gl_grpParciales.horizontalSpacing = 2;
		gl_grpParciales.marginHeight = 2;
		grpParciales.setLayout(gl_grpParciales);
		GridData gd_grpParciales = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_grpParciales.widthHint = 200;
		gd_grpParciales.heightHint = 150;
		grpParciales.setLayoutData(gd_grpParciales);
		
		Label lblParcialesMateriaClase = new Label(grpParciales, SWT.NONE);
		lblParcialesMateriaClase.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblParcialesMateriaClase.setText("Materia:");
		
		Combo comboParcialesMateriaClase = new Combo(grpParciales, SWT.READ_ONLY);
		comboParcialesMateriaClase.setToolTipText("Elige la materia para gestionar sus parciales.");
		comboParcialesMateriaClase.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		comboConIdParcialesMateria = new ComboConId(comboParcialesMateriaClase);
		comboParcialesMateriaClase.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboParcialesMateriaClase");
				MateriaClase.fijarMateriaClase(comboConIdParcialesMateria.idSeleccionado(), MateriaClase.getIdClaseDeTrabajo());
				actualizarParcialesLista(null);
			}
		});
		
		List listParciales = new List(grpParciales, SWT.BORDER | SWT.V_SCROLL);
		listParciales.setToolTipText("Parciales de la materia seleccionada.");
		GridData gd_listParciales = new GridData(SWT.FILL, SWT.FILL, true, true, 3, 1);
		gd_listParciales.heightHint = 50;
		listParciales.setLayoutData(gd_listParciales);
		listConIdParciales = new ListConId(listParciales);
		listParciales.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("listParciales "+listConIdParciales.idSeleccionado());
				actualizarParcialDatos();
			}
		});
		
		Label lblParcialInicio = new Label(grpParciales, SWT.NONE);
		lblParcialInicio.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblParcialInicio.setText("Inicio:");
		
		Combo comboParcialInicio = new Combo(grpParciales, SWT.READ_ONLY);
		comboParcialInicio.setToolTipText("Primer día del parcial seleccionado.");
		comboParcialInicio.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		fechaComboParcialInicio = new FechaCombo(comboParcialInicio);
		comboParcialInicio.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboParcialInicio");
				BBDD.modificarParcial(listConIdParciales.idSeleccionado(),fechaComboParcialInicio.fechaSeleccionada(),fechaComboParcialFin.fechaSeleccionada());
				actualizarParcialesLista(null);
				Parcial.defParciales();
			}
		});
		
		Composite compositeParcialesNuevoBorrar = new Composite(grpParciales, SWT.NONE);
		compositeParcialesNuevoBorrar.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, false, 1, 2));
		GridLayout gl_compositeParcialesNuevoBorrar = new GridLayout(1, false);
		gl_compositeParcialesNuevoBorrar.horizontalSpacing = 2;
		gl_compositeParcialesNuevoBorrar.marginHeight = 2;
		gl_compositeParcialesNuevoBorrar.verticalSpacing = 2;
		gl_compositeParcialesNuevoBorrar.marginWidth = 2;
		compositeParcialesNuevoBorrar.setLayout(gl_compositeParcialesNuevoBorrar);
		
		btnParcialNuevo = new Button(compositeParcialesNuevoBorrar, SWT.NONE);
		btnParcialNuevo.setToolTipText("Crear un nuevo parcial para la materia seleccionada.");
		btnParcialNuevo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnParcialesNuevo");
				Vector<Vector<String>> parciales=BBDD.consultarParcial(comboConIdParcialesMateria.idSeleccionado(),null);
				Calendar inicio=null;
				Calendar fin=Fecha.finCurso;
				int i=parciales.size()-1;
				if (i<0) {
					inicio=Fecha.inicioCurso;
				} else {
					inicio=Fecha.fecha(parciales.get(i).get(5),parciales.get(i).get(6),parciales.get(i).get(7));
					inicio.add(Calendar.DAY_OF_MONTH,+1);
					inicio=Fecha.diaLaboralOSiguiente(inicio, true);
				}
				//System.out.println("parciales "+i+": inicioCurso"+Fecha.formaFechaDiaHora(Fecha.finCurso)+" inicio"+Fecha.formaFechaDiaHora(inicio));
				if (Fecha.finCurso.compareTo(inicio)<=0) {
					PCuaderno.MiPCuaderno.informacion("No quedan días para otro parcial. Imposible añadir un nuevo parcial.");
				} else {
					String id=BBDD.insertarParcial(comboConIdParcialesMateria.idSeleccionado(),inicio,fin);
					actualizarParcialesLista(id);
					Parcial.defParciales();
				} 
			}
		});
		btnParcialNuevo.setText("Nuevo");
		
		btnParcialBorrar = new Button(compositeParcialesNuevoBorrar, SWT.NONE);
		btnParcialBorrar.setToolTipText("Borrar el parcial seleccionado.");
		btnParcialBorrar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnParcialesBorrar");
				if (listConIdParciales.idSeleccionado()!=null){
					BBDD.borrarParcial(listConIdParciales.idSeleccionado());
					listConIdParciales.seleccionarSiguienteOAnterior();
					actualizarParcialesLista(null);
					Parcial.defParciales();
				}
			}
		});
		btnParcialBorrar.setText("Borrar");
		
		Label lblParcialFin = new Label(grpParciales, SWT.NONE);
		lblParcialFin.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblParcialFin.setText("Fin:");
		
		Combo comboParcialFin = new Combo(grpParciales, SWT.READ_ONLY);
		comboParcialFin.setToolTipText("Último día del parcial seleccionado.");
		comboParcialFin.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		fechaComboParcialFin = new FechaCombo(comboParcialFin);
		comboParcialFin.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("comboParcialFin");
				BBDD.modificarParcial(listConIdParciales.idSeleccionado(),fechaComboParcialInicio.fechaSeleccionada(),fechaComboParcialFin.fechaSeleccionada());
				actualizarParcialesLista(null);
				Parcial.defParciales();
			}
		});

		//+++++++++++++++++++++++++++++Almacen
		
		Group groupAlmacen = new Group(this, SWT.NONE);
		groupAlmacen.setText("Acciones:");
		GridData gd_groupAlmacen = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_groupAlmacen.widthHint = 100;
		gd_groupAlmacen.heightHint = 150;
		groupAlmacen.setLayoutData(gd_groupAlmacen);
		GridLayout gl_groupAlmacen = new GridLayout(1, false);
		gl_groupAlmacen.verticalSpacing = 2;
		gl_groupAlmacen.marginWidth = 2;
		gl_groupAlmacen.marginHeight = 2;
		gl_groupAlmacen.horizontalSpacing = 2;
		groupAlmacen.setLayout(gl_groupAlmacen);
		
		Button btnAlmacenHacer = new Button(groupAlmacen, SWT.NONE);
		btnAlmacenHacer.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		btnAlmacenHacer.setText("Copiar");
		btnAlmacenHacer.setToolTipText("Hacer una copia de seguridad del información actual. Seguira siendo " +
				"necesaria la clave actual para poder utilizar esta copia en el futuro.");
		btnAlmacenHacer.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnAlmacenHacer");
				BBDD.copiaSeguridadHacer();
			}
		});
		
		Button btnAlmacenRestaurar = new Button(groupAlmacen, SWT.NONE);
		btnAlmacenRestaurar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		btnAlmacenRestaurar.setText("Restaurar");
		btnAlmacenRestaurar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnAlmacenRestaurar");
				String m="Se borrarán todos los datos actuales y se implantarán los" +
						" almacenados en la copia de seguridad que seleccione. Necesitará saber" +
						" la clave de la copia que desee restaurar. ¿Desea continuar?";
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					BBDD.cerrarBBDD();
			        FileDialog fd = new FileDialog(PCuaderno.MiPCuaderno.shellPrincipal, SWT.OPEN);
			        fd.setText("Restaurar la copia del archivo");
			        fd.setFilterPath(BBDD.dirBBDD);
			        String[] filterExt = { "*.zip","*.*" };
			        fd.setFilterExtensions(filterExt);
			        String nomArchivo = fd.open();
			        if (nomArchivo!=null) {
						BBDD.copiaSeguridadRestaurar(nomArchivo);
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Preguntando contraseña...");
						String acceso=PCuaderno.MiPCuaderno.md5(PCuaderno.MiPCuaderno.entrada("Clave","Introduzca la clave que tenía definida cuando hizo copia de seguridad que desea restaurar. Esta será la usada a partir de ahora para acceder al programa.",true));
						if (acceso!=null) 
							if (BBDD.acceso(acceso)){
								acceso=null;
								PCuaderno.MiPCuaderno.iniciar();
								actualizar();PCuaderno.MiPCuaderno.calendario.actualizarCalendario();
							} else {
								acceso=null;
								m="No pudo conectar con la base de datos, probablemente sea por que la clave" +
										" introducida no es correcta. El programa se cerrará.";
								PCuaderno.MiPCuaderno.informacion(m);
								PCuaderno.MiPCuaderno.shellPrincipal.dispose();
								PCuaderno.MiPCuaderno.display.dispose();
							}
			        }
				}
			}
		});
		
		Button btnAlmacenLimpiar = new Button(groupAlmacen, SWT.NONE);
		btnAlmacenLimpiar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		btnAlmacenLimpiar.setText("Limpiar");
		btnAlmacenLimpiar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnAlmacenLimpiar");
				String m="Se borrarán todos los datos actuales. ¿Desea continuar?";
				int buttonID = PCuaderno.MiPCuaderno.aviso(m);
				if (buttonID == SWT.OK) {
					BBDD.limpiarBBDD();
					PCuaderno.MiPCuaderno.iniciar();
					actualizar();
					actualizar();PCuaderno.MiPCuaderno.calendario.actualizarCalendario();
				}
			}
		});
		
		btnProfesorClave = new Button(groupAlmacen, SWT.CENTER);
		btnProfesorClave.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		btnProfesorClave.setToolTipText("Cambiar la clave del usuario.");
		btnProfesorClave.setText("Clave");
		btnProfesorClave.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnProfesorClave");
				String m="Se hara una copia de seguridad y a continuación se le pedirá la nueva clave. ¿Desea continuar?";
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) {
					if (BBDD.modificarClave(PCuaderno.MiPCuaderno.md5(PCuaderno.MiPCuaderno.entrada("Nueva clave","Introduzca la NUEVA clave para acceder al programa.",true)))) {
						actualizar();
					} else {
						m="No pudo conectar con la base de datos, probablemente sea por que la clave" +
								" introducida no es correcta. El programa se cerrará.";
						PCuaderno.MiPCuaderno.informacion(m);
						PCuaderno.MiPCuaderno.shellPrincipal.dispose();
						PCuaderno.MiPCuaderno.display.dispose();		
					}
				}
			}
		});
		
		Button btnAcercaDe = new Button(groupAlmacen, SWT.NONE);
		btnAcercaDe.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		btnAcercaDe.setText("Acerca de");
		btnAcercaDe.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnAcercaDe");
				String m=PCuaderno.MiPCuaderno.titulo+" versión "
						+PCuaderno.MiPCuaderno.version+"\n\n"+PCuaderno.MiPCuaderno.descripcion+"\n\n"
						+PCuaderno.MiPCuaderno.usando+"\n\nAutor: Ismael PONCE GORDILLO." +
						"\nLicencia EUPLv1.1 Copyright 2012";
				PCuaderno.MiPCuaderno.informacion(m);
			}
		});
	}
	public void actualizarParcialesLista(String idSeleccionado){
		listConIdParciales.rellenarParciales(comboConIdParcialesMateria.idSeleccionado());
		listConIdParciales.seleccionarId(idSeleccionado);
		actualizarParcialDatos();
	}
	public void actualizarParcialDatos(){
		if (listConIdParciales.idSeleccionado()==null){
			btnParcialNuevo.setEnabled(true);
			btnParcialBorrar.setEnabled(false);
			fechaComboParcialInicio.borrar();fechaComboParcialInicio.deshabilitar();
			fechaComboParcialFin.borrar();fechaComboParcialFin.deshabilitar();
		} else {
			Vector<Vector<String>> parciales=BBDD.consultarParcial(comboConIdParcialesMateria.idSeleccionado(),null);
			Calendar linInfInicio=null;
			Calendar linSupInicio=null;
			Calendar linInfFin=null;
			Calendar linSupFin=null;
			Calendar inicio=null;
			Calendar fin=null;
			for (int i=0;i<parciales.size();i++) {
				//System.out.println("parciales "+i+": id"+parciales.get(i).get(0)+" selid"+listConIdParciales.idSeleccionado());
				if (parciales.get(i).get(0).equals(listConIdParciales.idSeleccionado())) {
					if (i==0) {
						linInfInicio=(Calendar)Fecha.inicioCurso.clone();
					} else {
						linInfInicio=Fecha.fecha(parciales.get(i-1).get(5),parciales.get(i-1).get(6),parciales.get(i-1).get(7));
						linInfInicio.add(Calendar.DAY_OF_MONTH,+1);
						linInfInicio=Fecha.diaLaboralOSiguiente(linInfInicio, true);
					}
					inicio=Fecha.fecha(parciales.get(i).get(2),parciales.get(i).get(3),parciales.get(i).get(4));
					linInfFin=(Calendar)inicio.clone();
					linInfFin.add(Calendar.DAY_OF_MONTH,+1);
					linInfFin=Fecha.diaLaboralOSiguiente(linInfFin, true);
					fin=Fecha.fecha(parciales.get(i).get(5),parciales.get(i).get(6),parciales.get(i).get(7));
					linSupInicio=(Calendar)fin.clone();
					linSupInicio.add(Calendar.DAY_OF_MONTH,-1);
					linSupInicio=Fecha.diaLaboralOAnterior(linSupInicio, true);
					if (i==parciales.size()-1) {
						linSupFin=(Calendar)Fecha.finCurso.clone();
					} else {
						linSupFin=Fecha.fecha(parciales.get(i+1).get(2),parciales.get(i+1).get(3),parciales.get(i+1).get(4));
						linSupFin.add(Calendar.DAY_OF_MONTH,-1);
						linSupFin=Fecha.diaLaboralOAnterior(linSupFin, true);
					}
					break;
				}
			}
			fechaComboParcialInicio.rellenarLectivosDesdeHastaFecha(linInfInicio,linSupInicio,true);
			fechaComboParcialInicio.seleccionarFecha(inicio);fechaComboParcialInicio.habilitar();
			fechaComboParcialFin.rellenarLectivosDesdeHastaFecha(linInfFin,linSupFin,true);
			fechaComboParcialFin.seleccionarFecha(fin);fechaComboParcialFin.habilitar();
			btnParcialBorrar.setEnabled(true);
			btnParcialNuevo.setEnabled(true);
			int uP=parciales.size()-1;
			if (uP>=0) 
				if (Fecha.finCurso.compareTo(Fecha.fecha(parciales.get(uP).get(5),parciales.get(uP).get(6),parciales.get(uP).get(7)))<=0)
					btnParcialNuevo.setEnabled(false);
		}
		if (comboConIdParcialesMateria.idSeleccionado()==null) btnParcialNuevo.setEnabled(false); 
	}
	public void actualizarProfesoresLista(String idSeleccionado){
		listConIdProfesores.rellenarProfesores();
		listConIdProfesores.seleccionarId(idSeleccionado);
		actualizarProfesorDatos();
	}
	public void actualizarProfesorDatos(){
		if (listConIdProfesores.idSeleccionado()==null){
			TextoDemorado.modificaSinActualizar(txtProfesorNombre,"");txtProfesorNombre.setEnabled(false);
			TextoDemorado.modificaSinActualizar(txtProfesorApellidos,"");txtProfesorApellidos.setEnabled(false);
			TextoDemorado.modificaSinActualizar(txtProfesorDatos,"");txtProfesorDatos.setEnabled(false);
			btnProfesorBorrar.setEnabled(false);
		} else {
			Vector<Vector<String>> profesores=BBDD.consultarProfesor(listConIdProfesores.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtProfesorNombre,profesores.get(0).get(1));
			TextoDemorado.modificaSinActualizar(txtProfesorApellidos,profesores.get(0).get(2));
			TextoDemorado.modificaSinActualizar(txtProfesorDatos,((profesores.get(0).get(3)!=null)?profesores.get(0).get(3):""));
			btnProfesorBorrar.setEnabled(true);
		}
	}
	public void actualizarTiposEvaluablesLista(String idSeleccionado){
		listConIdTiposEvaluables.rellenarTiposEvaluables(((comboConIdTiposEvaluablesMateria.idSeleccionado().equals(BBDD.idTodos))?null:comboConIdTiposEvaluablesMateria.idSeleccionado()));
		listConIdTiposEvaluables.seleccionarId(idSeleccionado);
		actualizarTiposEvaluablesDatos();
	}
	public void actualizarTiposEvaluablesDatos(){
		if (listConIdTiposEvaluables.idSeleccionado()==null){
			txtTiposEvaluablesDescripcion.setEnabled(false);txtTiposEvaluablesDescripcion.setText("");
			txtTiposEvaluablesReferencia.setEnabled(false);txtTiposEvaluablesReferencia.setText("");
			txtTiposEvaluablesPeso.setEnabled(false);txtTiposEvaluablesPeso.setText("");
			txtTiposEvaluablesMinimo.setEnabled(false);txtTiposEvaluablesMinimo.setText("");
			btnTiposEvaluablesBorrar.setEnabled(false);
		} else {
			TextoDemorado.escribeSiHay();
			Vector<Vector<String>> tipoEvaluable=BBDD.consultarTiposEvaluables(listConIdTiposEvaluables.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtTiposEvaluablesReferencia,tipoEvaluable.get(0).get(1));
			TextoDemorado.modificaSinActualizar(txtTiposEvaluablesDescripcion,tipoEvaluable.get(0).get(2));
			TextoDemorado.modificaSinActualizar(txtTiposEvaluablesPeso,tipoEvaluable.get(0).get(3));
			TextoDemorado.modificaSinActualizar(txtTiposEvaluablesMinimo,Numero.cadenaDecimal(Double.parseDouble(tipoEvaluable.get(0).get(4))));
			btnTiposEvaluablesBorrar.setEnabled(true);
		}
	}
	public void actualizarDiasNoLectivosLista(String idSeleccionado){
		listConIdDiasNoLectivos.rellenarDiasNoLectivos();
		listConIdDiasNoLectivos.seleccionarId(idSeleccionado);
		actualizarDiaNoLectivoDatos();
	}
	public void actualizarDiaNoLectivoDatos(){
		if (listConIdDiasNoLectivos.idSeleccionado()==null){
			txtDiaNoLectivoDescripcion.setEnabled(false);txtDiaNoLectivoDescripcion.setText("");
			fechaComboDiaNoLectivoFecha.borrar();
			fechaComboDiaNoLectivoFecha.deshabilitar();
			comboConIdDiaNoLectivoClase.deshabilitar();
			btnDiaNoLectivoBorrar.setEnabled(false);
		} else {
			TextoDemorado.escribeSiHay();
			Vector<String> noLectivo=BBDD.consultarDiaNoLectivo(listConIdDiasNoLectivos.idSeleccionado());
			TextoDemorado.modificaSinActualizar(txtDiaNoLectivoDescripcion,noLectivo.get(5));
			fechaComboDiaNoLectivoFecha.rellenarLectivosYDiaConcreto(Fecha.fecha(noLectivo.get(2),noLectivo.get(3),noLectivo.get(4)));
			fechaComboDiaNoLectivoFecha.seleccionarFecha(Fecha.fecha(noLectivo.get(2),noLectivo.get(3),noLectivo.get(4)));
			comboConIdDiaNoLectivoClase.seleccionarId(((noLectivo.get(1)!=null)?noLectivo.get(1):BBDD.idDiaCompleto));
			fechaComboDiaNoLectivoFecha.habilitar();
			comboConIdDiaNoLectivoClase.habilitar();
			btnDiaNoLectivoBorrar.setEnabled(true);
		}
	}
}
