/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.widgets.Combo;

public class Parcial {
	private Calendar fPrimera;
	private Calendar fUltima;
	private Parcial (Calendar primera, Calendar ultima){
		this.fPrimera=primera;
		this.fUltima=ultima;
		//Parcial.parciales.addElement(this);
		//System.out.println("Parcial "+Parcial.parciales.size()+": i = "+Fecha.formaFechaDia(Parcial.parciales.get(Parcial.parciales.size()-1).getfPrimera())+", f = "+Fecha.formaFechaDia(Parcial.parciales.get(Parcial.parciales.size()-1).getfUltima())+".");
	}
	public Calendar getfPrimera() {return fPrimera;}
	public Calendar getfUltima() {return fUltima;}

	private static Vector<Parcial> parciales = new Vector<Parcial>();
	public static void inicializar(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Parcial FechaDeTrabajo = "+Parcial.getParcial(Fecha.fechaDeTrabajo));
	}
	public static void defParciales(){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()");
		Parcial.parciales.removeAllElements();
		Vector<Vector<String>> fechas = BBDD.consultarParcial(MateriaClase.getIdMateriaDeTrabajo(),null);
		if (fechas!=null)
			for (int i=0;i<fechas.size();i++){
				Calendar fi = Fecha.fechaHora(fechas.get(i).get(2),fechas.get(i).get(3),fechas.get(i).get(4),"0","0");
				Calendar ff = Fecha.fechaHora(fechas.get(i).get(5),fechas.get(i).get(6),fechas.get(i).get(7),"23","59");
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+i+": "+Fecha.formaFecha(fi)+" - "+Fecha.formaFecha(ff));
				Parcial p = new Parcial(fi,ff);
				Parcial.parciales.add(p);
			}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+Parcial.parciales.size()+" parciales.");
	}
	public static void setParcialDeTrabajo(Integer p){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+")");
		Calendar fechaActual=Fecha.getFechaHoraLaboralOSiguiente(Calendar.getInstance(), true);
		Integer parcialActual=getParcial(fechaActual);
		if (p.equals(parcialActual)) Fecha.fechaDeTrabajo=fechaActual;
		else Fecha.fechaDeTrabajo=Fecha.getFechaHoraLaboralOSiguiente((Calendar)Parcial.getFechaInicioParcial(p), true);
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+") => FechaTrabajo ("+Fecha.formaFechaDiaHora(Fecha.fechaDeTrabajo)+") fin");
	}
	public static void rellenarParciales(Combo comboParciales){
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("(combo)");
		if (comboParciales!=null) {
			comboParciales.removeAll();
			for (int p=1;p<=parciales.size();p++){
				comboParciales.add(String.valueOf(p));
				if (p==Parcial.getParcial(Fecha.fechaDeTrabajo)) comboParciales.select(p-1);
			}
			if (comboParciales.getSelectionIndex()<0) comboParciales.select(0);
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("() "+comboParciales.getItemCount()+" elementos");
	}
	public static int getParcial(Calendar f){
		int p=-1;
		if (Parcial.parciales.size()>0) {
			if (f.compareTo(Parcial.parciales.get(0).getfPrimera())<0) {
				//System.out.println("Parcial getParcial error: fecha anterior al primer dia de curso p=1 ("+Fecha.formaFechaDia(f)+"<"+Fecha.formaFechaDia(Parcial.parciales.get(0).getfPrimera()));
				//p=-1;
				p=1;
			} else {
				p=0;
				do {
					p++;
					//System.out.println(" parcial "+p+", "+Fecha.formaFecha(Parcial.parciales.get(p-1).getfUltima()));
				} while (p<parciales.size() && f.compareTo(Parcial.parciales.get(p).getfPrimera())>0);
				//System.out.println("Parcial getParcial para "+Fecha.formaFecha(f)+ " = "+p);
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+Fecha.formaFechaDiaHora(f)+") "+p);
		return p; // el vector empieza en 0 pero yo trabajo empezando en 1 para primer parcial
	}
	public static Calendar getFechaInicioParcial(int p){
		Calendar f = null;
		if (p>0 && p<=parciales.size()) f=Parcial.parciales.get(p-1).getfPrimera(); 
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+") "+Fecha.formaFechaDiaHora(f));
		return f;
	}
	public static Calendar getFechaFinParcial(int p){
		Calendar f = null;
		if (p>0 && p<=parciales.size()) f=Parcial.parciales.get(p-1).getfUltima();  
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+p+") "+Fecha.formaFechaDiaHora(f));
		return f;
	}
	public static int numeroDiasCurso(){return Parcial.getFechaFinParcial(Parcial.numeroParciales()).compareTo(Parcial.getFechaInicioParcial(1));}
	public static int numeroParciales(){return Parcial.parciales.size();}
	public static void imprimirParciales(){
		for (int i=1;i<=Parcial.parciales.size();i++)
			if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Parcial "+i+": "+Fecha.formaFechaDia(Parcial.getFechaInicioParcial(i)) +
					" - "+Fecha.formaFechaDia(Parcial.getFechaFinParcial(i)));		
	}
/*	private static void defParcialesDefecto(){
		Calendar iParcial,fParcial;
		Parcial p=null;
		// inicio primer parcial, inicio curso
		iParcial = (Calendar) Fecha.fechaDeTrabajo.clone();
		iParcial.set(Calendar.YEAR, (iParcial.get(Calendar.MONTH)<Fecha.MesInicioCalendario)?iParcial.get(Calendar.YEAR)-1:iParcial.get(Calendar.YEAR));
		iParcial.set(Calendar.MONTH, Fecha.MesInicioCalendario);
		iParcial.set(Calendar.DAY_OF_MONTH, 1);
		// fin del primer parcial principio del segundo, fin de año
		fParcial=(Calendar) Fecha.fechaDeTrabajo.clone();
		fParcial.set(Calendar.YEAR,((fParcial.get(Calendar.MONTH)<Fecha.MesInicioCalendario)?fParcial.get(Calendar.YEAR)-1:fParcial.get(Calendar.YEAR)));
		fParcial.set(Calendar.MONTH, Calendar.DECEMBER);
		fParcial.set(Calendar.DAY_OF_MONTH, fParcial.getActualMaximum(Calendar.DAY_OF_MONTH));
		p = new Parcial(iParcial,fParcial);
		// segundo parcial primero del tercero,semana santita, quien inventó esto? y el mes 0 de java.
		iParcial = (Calendar) fParcial.clone();
		iParcial.add(Calendar.DAY_OF_MONTH, +1);
		fParcial=Calendar.getInstance();
		int agno=(fParcial.get(Calendar.MONTH)<Fecha.MesInicioCalendario)?fParcial.get(Calendar.YEAR):fParcial.get(Calendar.YEAR)+1;
		int M=24,N=5,a,b,c,d,e,dia,mes;
		if (agno >= 1583 && agno <= 1699){M = 22;N = 2;
        }else if ( agno >=1700 && agno <= 1799){M = 23;N = 3;
        }else if ( agno >=1800 && agno <= 1899){M = 23;N = 4;
        }else if ( agno >=1900 && agno <=2099){M = 24;N = 5;
        }else if ( agno >=2100 && agno <=2199){M= 24;N= 6;
        }else if ( agno>=2200 && agno <= 2299){M= 25;N= 0;}
		a = agno % 19;b = agno % 4;c = agno % 7;d = (19*a + M) % 30;e = (2*b+4*c+6*d + N) % 7;
	    if (d+e < 10)  {dia = d+e+22;mes = Calendar.MARCH;
	    }else{dia = d+e-9;mes = Calendar.APRIL;}
	    if (dia == 26  && mes == Calendar.APRIL) dia = 19;
	    if (dia == 25 && mes == Calendar.APRIL && d==28 && e == 6 && a >10) dia = 18;
	    fParcial.set(Calendar.YEAR,agno);
	    fParcial.set(Calendar.MONTH, mes);
	    fParcial.set(Calendar.DAY_OF_MONTH, dia);
		p = new Parcial(iParcial,fParcial);
		iParcial = (Calendar) fParcial.clone();
		iParcial.add(Calendar.DAY_OF_MONTH, +1);
		fParcial = (Calendar) Fecha.fechaDeTrabajo.clone();
		fParcial.set(Calendar.YEAR, (fParcial.get(Calendar.MONTH)<Fecha.MesInicioCalendario)?fParcial.get(Calendar.YEAR)-1:fParcial.get(Calendar.YEAR));
		fParcial.set(Calendar.MONTH, Fecha.MesInicioCalendario);
		fParcial.add(Calendar.MONTH, +Fecha.MesesLectivosCalendario-1);
		fParcial.set(Calendar.DAY_OF_MONTH, fParcial.getActualMaximum(Calendar.DAY_OF_MONTH));
		p = new Parcial(iParcial,fParcial);
	}*/
}