/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Calendar;
import java.util.Vector;

import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.custom.TreeEditor;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.TreeItem;

public class Programacion extends Composite {
	private Label labelMateria;
	private Combo comboMateria;
	private Tree treeIndice;
	private Button btnAdelantarNodo;
	private Button btnSubirNodo;
	private Button btnCrearNodoHijo;
	private Button btnBorrarNodo;
	private Button btnBajarNodo;
	private Button btnRetrasarNodo;
	private Text textSumario;public Text getTextSumario() {return textSumario;}
	private Text textDuracion;public Text getTextDuracion() {return textDuracion;}
	private Group grpSumario;
	private ComboConId comboConIdMateria;
	private Label lblClase;
	private Combo comboClase;
	private ComboConId comboConIdClase;
	private TreeConId treeConIdIndice;public TreeConId getTreeConIdIndice() {return treeConIdIndice;}
	private Group grpDistTemporal;
	private Group grpPorImpartir;
	private Group grpNodo;
	private Label lblDisponible;
	private Label lblTermina;
	private Label lblRequerido;
	private Integer disponibleTotal;
	private Button btnCrearHermano;
	private Button btnImportar;

	public Programacion(Composite parent, int style) {super(parent, style);initialize();}

	public void actualizar() {
		comboConIdMateria.rellenarMaterias(false);
		comboConIdMateria.seleccionarId(MateriaClase.getIdMateriaDeTrabajo());
		comboConIdClase.seleccionarId(MateriaClase.getIdClaseDeTrabajo());
		ponerArbol(null);
		actualizarClase();
		btnImportar.setEnabled(comboConIdClase.idSeleccionado()!=null);
	}
	private void initialize() {
		GridLayout gridLayoutProgramacion = new GridLayout();
		gridLayoutProgramacion.numColumns = 2;
		gridLayoutProgramacion.horizontalSpacing = 2;
		gridLayoutProgramacion.verticalSpacing = 2;
		gridLayoutProgramacion.marginWidth = 2;
		gridLayoutProgramacion.marginHeight = 2;
		GridData gridDataProgramacion = new GridData();
		gridDataProgramacion.grabExcessHorizontalSpace = true;
		gridDataProgramacion.grabExcessVerticalSpace = true;
		gridDataProgramacion.horizontalAlignment = GridData.FILL;
		gridDataProgramacion.verticalAlignment = GridData.FILL;
		this.setLayoutData(gridDataProgramacion);
		this.setSize(new Point(685, 340));
		setLayout(gridLayoutProgramacion);

		creaCompositeMateriaGrupo();
		creaGrupoContenido();

		treeIndice = new Tree(this, SWT.BORDER);
		treeIndice.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				actualizarDatosNodo();
			}
		});
		GridData gd_treeIndice = new GridData(SWT.FILL, SWT.FILL, true, true,
				1, 1);
		gd_treeIndice.heightHint = 100;
		gd_treeIndice.widthHint = 200;
		treeIndice.setLayoutData(gd_treeIndice);
		treeIndice.setLinesVisible(true);
		treeConIdIndice = new TreeConId(treeIndice);
		treeIndice
				.setToolTipText("Seleccione un enunciado para ver sus datos o operar con él. Si desea modificar el enunciado pulse 'F2'.");
		final TreeEditor editor = new TreeEditor(treeIndice);
		editor.horizontalAlignment = SWT.LEFT;
		editor.grabHorizontal = true;
		treeIndice.addKeyListener(new KeyAdapter() {
			public void keyPressed(KeyEvent event) {
				if (event.keyCode == SWT.F2
						&& treeIndice.getSelectionCount() == 1) {
					final TreeItem nodoSeleccionado = treeIndice.getSelection()[0];
					final Text text = new Text(treeIndice, SWT.NONE);
					text.setText(nodoSeleccionado.getText());
					text.selectAll();
					text.setFocus();
					text.addFocusListener(new FocusAdapter() {
						public void focusLost(FocusEvent event) {
							nodoSeleccionado.setText(text.getText());
							text.dispose();
						}
					});
					text.addKeyListener(new KeyAdapter() {
						public void keyPressed(KeyEvent event) {
							switch (event.keyCode) {
							case SWT.CR:
								BBDD.modificarProgramcionNodoEnunciado(
										treeConIdIndice.getId(nodoSeleccionado),
										text.getText());
								nodoSeleccionado.setText(text.getText());
							case SWT.ESC:
								text.dispose();
								treeIndice.setFocus();
								break;
							}
						}
					});
					editor.setEditor(text, nodoSeleccionado);
				}
			}
		});

		creaGrupoNodos();
		creaGrupoDuracion();

		grpSumario = new Group(this, SWT.NONE);
		grpSumario.setText("Sumario");
		GridData gd_grpSumario = new GridData(SWT.FILL, SWT.FILL, true, true,
				2, 1);
		gd_grpSumario.heightHint = 80;
		grpSumario.setLayoutData(gd_grpSumario);
		grpSumario.setLayout(new GridLayout(2, false));

		textSumario = new Text(grpSumario, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL);
		textSumario.setToolTipText("Introduzca la información que crea conveniente para el enunciado seleccionado.");
		textSumario.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true,
				2, 1));
		treeIndice.setFocus();
		TextoDemorado.add(textSumario,false,1024,null,null,true,treeConIdIndice,null);
		actualizarClase();
	}

	private void creaCompositeMateriaGrupo() {
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false,
				1, 1));
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);

		labelMateria = new Label(composite, SWT.NONE);
		labelMateria.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		labelMateria.setText("Materia:");

		comboMateria = new Combo(composite, SWT.READ_ONLY);
		comboMateria.setToolTipText("Elija una materia sobre la que quiere gestionar la programación.");
		comboMateria.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				comboConIdClase.rellenarClases(comboConIdMateria.idSeleccionado(),null,null);
				MateriaClase.fijarMateriaClase(
						comboConIdMateria.idSeleccionado(),
						comboConIdClase.idSeleccionado());
				ponerArbol(null);
				actualizarClase();
			}
		});
		GridData gd_comboMateria = new GridData(SWT.FILL, SWT.FILL, true,
				false, 1, 1);
		gd_comboMateria.widthHint = 200;
		comboMateria.setLayoutData(gd_comboMateria);
		comboConIdMateria = new ComboConId(comboMateria);
	}

	private void creaGrupoContenido() {
		Group grpGestorNodos = new Group(this, SWT.NONE);
		grpGestorNodos.setText("Enunciado");
		GridData gd_grpGestorNodos = new GridData(SWT.FILL, SWT.FILL, false,false, 1, 3);
		gd_grpGestorNodos.heightHint = 200;
		grpGestorNodos.setLayoutData(gd_grpGestorNodos);
		grpGestorNodos.setLayout(new GridLayout(1, false));
		
		btnAdelantarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnAdelantarNodo
				.setToolTipText("Intercambiar con el elemento anterior de igual nivel.");
		btnAdelantarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		btnAdelantarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoHermanoAnterior = treeConIdIndice
						.getHermanoAnterior(nodoSeleccionado);
				if (nodoSeleccionado != null && nodoHermanoAnterior != null) {
					BBDD.modificarProgramcionNodoIntercambiaPos(
							treeConIdIndice.getIdSeleccionado(),
							treeConIdIndice.getId(nodoHermanoAnterior));
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Progrmacion btnAdelantarNodo idNodoSeleccionado="
									+ treeConIdIndice.getIdSeleccionado()
									+ ", nodo=" + nodoSeleccionado.handle);
					ponerArbol(null);
				}
				treeIndice.setFocus();
			}
		});
		btnAdelantarNodo.setText("Adelantar");
				
		btnSubirNodo = new Button(grpGestorNodos, SWT.NONE);
		btnSubirNodo
				.setToolTipText("Ascender de nivel. Si es el último detrás del elemento de nivel superior del que colgaba, sino delante.");
		btnSubirNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		btnSubirNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				// si el es último de los hermanos sube detras del padre
				// si no sube delante del padre
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoPadre = treeConIdIndice.getPadre(nodoSeleccionado);
				if (nodoPadre != null) {
					TreeItem nodoHermanoPosterior = treeConIdIndice
							.getHermanoPosterior(nodoSeleccionado);
					String idNodoSeleccionado = treeConIdIndice
							.getIdSeleccionado();
					String idPadre = treeConIdIndice.getId(nodoPadre);
					BBDD.modificarProgramcionNodoSubirNodo(idNodoSeleccionado);
					if (nodoHermanoPosterior == null)
						BBDD.modificarProgramcionNodoIntercambiaPos(
								idNodoSeleccionado, idPadre);
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Progrmacion btnSubirNodo idNodoSeleccionado="
									+ idNodoSeleccionado
									+ ", nodo="
									+ treeConIdIndice
											.getNodo(idNodoSeleccionado));
					ponerArbol(null);
				}
				treeIndice.setFocus();
			}
		});
		btnSubirNodo.setText("Subir");
						
		btnCrearNodoHijo = new Button(grpGestorNodos, SWT.NONE);
		btnCrearNodoHijo.setToolTipText("Crea un subelemento dentro del elemento actual en la última posición.");
		btnCrearNodoHijo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		btnCrearNodoHijo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Creando Nodo Hijo");
				if (comboConIdMateria.numeroElementos().equals(0)) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber creado una materia.");
				} else if (comboConIdMateria.idSeleccionado()==null) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber seleccionado una materia.");
				/*} else if (comboParcial.getItemCount()==0) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber creado al menos un parcial en la pestaña 'Mantenimiento' para la materia seleccionada.");
				} else if (comboParcial.getSelectionIndex()<0) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber seleccionado un parcial.");
				} else if (comboConIdTipo.numeroElementos().equals(0)) {
					PCuaderno.MiPCuaderno.error("No puede crear un nuevo evaluable sin haber creado una tipo de ítem evaluable genérico o especifico para esta materia en la pestaña 'Mantenimiento'.");
				*/} else {
					TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
					String idSeleccionado = treeConIdIndice.getIdSeleccionado();
					boolean nodoNuevo = false;
					Integer duracion = 0;
					if (nodoSeleccionado != null) {
						Vector<Vector<String>> temporal = BBDD
								.consultarProgramacionDuracionNodo(idSeleccionado,
										MateriaClase.getIdClaseDeTrabajo());
						if (temporal != null)
							if (temporal.size() > 0)
								duracion = Integer.valueOf(temporal.get(0).get(2));
						nodoNuevo = true;
						Integer orden = nodoSeleccionado.getItemCount() + 1;
						String idNodo = BBDD.insertarProgramacionNodo("Nuevo",
								treeConIdIndice.getId(nodoSeleccionado), orden,
								comboConIdMateria.idSeleccionado());
						BBDD.borrarProgramacionDuracionNodo(idSeleccionado,
								MateriaClase.getIdClaseDeTrabajo());
						if (duracion > 0)
							BBDD.insertarProgramacionDuracionNodo(idNodo,
									MateriaClase.getIdClaseDeTrabajo(), duracion);
						if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Programacion btnCrearNodoHijo " + orden
								+ ": (" + idNodo + ") Nuevo");
					} else {
						if (treeConIdIndice.getPrimero() == null) {
							nodoNuevo = true;
							String idNodo = BBDD.insertarProgramacionNodo("Nuevo",
									"NULL", 1, comboConIdMateria.idSeleccionado());
							if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Programacion btnCrearNodoHijo primero y único: ("
											+ idNodo + ") Nuevo");
						}
					}
					if (nodoNuevo) {
						ponerArbol(null);
					}
					treeIndice.setFocus();
				}
			}
		});
		btnCrearNodoHijo.setText("Crear Hijo");
								
		btnCrearHermano = new Button(grpGestorNodos, SWT.NONE);
		btnCrearHermano.setToolTipText("Crea un elemento siguiente al elemento actual.");
		btnCrearHermano.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		btnCrearHermano.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				if (nodoSeleccionado != null) {
					String idNodo = BBDD.insertarProgramacionNodoHermano(treeConIdIndice.getIdSeleccionado());
					ponerArbol(idNodo);
					//treeConIdIndice.expandir(idNodo);
				}
				treeIndice.setFocus();
			}
		});
		btnCrearHermano.setText("Crear Hermano");
										
		btnBorrarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnBorrarNodo
				.setToolTipText("Borra el elemento actual y todo lo que hubiera dentro.");
		btnBorrarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		btnBorrarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnBorrarNodo");
				int buttonID = SWT.OK;
				if (treeConIdIndice.seleccionadoTieneHijos()) {
					String m="Si borra el nodo borrará toda la información asociada a este nodo y sus hijos recursivamente. ¿Desea Seguir de todas formas?";
					buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				}
				if (buttonID == SWT.OK) {
					TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
					TreeItem padre = treeConIdIndice.getPadre(nodoSeleccionado);
					TreeItem hermanoAnterior = treeConIdIndice.getHermanoAnterior(nodoSeleccionado);
					TreeItem hermanoPosterior = treeConIdIndice.getHermanoPosterior(nodoSeleccionado);
					BBDD.borrarProgramacionNodo(treeConIdIndice.getId(nodoSeleccionado));
					if (padre != null) {
						treeConIdIndice.seleccionar(padre);
					} else {
						if (hermanoAnterior != null) {
							treeConIdIndice.seleccionar(hermanoAnterior);
						} else {
							if (hermanoPosterior != null) {
								treeConIdIndice.seleccionar(hermanoPosterior);
							}
						}
					}
					ponerArbol(null);
				}
				treeIndice.setFocus();
			}
		});
		btnBorrarNodo.setText("Borrar");
												
		btnBajarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnBajarNodo
				.setToolTipText("Descender de nivel. Si es el primero dentro del siguiente elemento de mismo nivel, sino dentro del elemento anterior.");
		btnBajarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		btnBajarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				// si el es primero de los hermanos baja el primero del hermano
		// posterior
		// si no baja el último del hermano anterior
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoHermanoPosterior = treeConIdIndice
						.getHermanoPosterior(nodoSeleccionado);
				TreeItem nodoHermanoAnterior = treeConIdIndice
						.getHermanoAnterior(nodoSeleccionado);
				if (nodoHermanoPosterior != null || nodoHermanoAnterior != null) {
					String idNodo = treeConIdIndice.getId(nodoSeleccionado);
					if (nodoHermanoAnterior == null) {
						String idPosterior = treeConIdIndice
								.getId(nodoHermanoPosterior);
						BBDD.modificarProgramcionNodoBajarNodo(idNodo,
								idPosterior, true);
					} else {
						String idAnterior = treeConIdIndice
								.getId(nodoHermanoAnterior);
						BBDD.modificarProgramcionNodoBajarNodo(idNodo,
								idAnterior, false);
					}
					ponerArbol(null);
				}
				treeIndice.setFocus();
			}
		});
		btnBajarNodo.setText("Bajar");
														
		btnRetrasarNodo = new Button(grpGestorNodos, SWT.NONE);
		btnRetrasarNodo
				.setToolTipText("Intercambiar con el elemento posterior de igual nivel.");
		btnRetrasarNodo.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				true, 1, 1));
		btnRetrasarNodo.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				TreeItem nodoSeleccionado = treeConIdIndice.selecionado();
				TreeItem nodoHermanoPosterior = treeConIdIndice
						.getHermanoPosterior(nodoSeleccionado);
				if (nodoSeleccionado != null && nodoHermanoPosterior != null) {
					BBDD.modificarProgramcionNodoIntercambiaPos(
							treeConIdIndice.getIdSeleccionado(),
							treeConIdIndice.getId(nodoHermanoPosterior));
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Progrmacion btnRetrasarNodo idNodoSeleccionado="
									+ treeConIdIndice.getIdSeleccionado()
									+ ", nodo=" + nodoSeleccionado.handle);
					ponerArbol(null);
				}
				treeIndice.setFocus();
			}
		});
		btnRetrasarNodo.setText("Retrasar");
		
		btnImportar = new Button(grpGestorNodos, SWT.NONE);
		btnImportar.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		btnImportar.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("btnImportar");
				String m="Se importará el indice de la materia de un archivo con el siguente formato: solo un enunciado por línea y esa linea comenzará con el numero de tabuladores según el nivel (el nivel más alto no tendrá tabulador). ¿Desea Seguir de todas formas?";
				int buttonID = PCuaderno.MiPCuaderno.pregunta(m);
				if (buttonID == SWT.OK) BBDD.importarProgramacion(MateriaClase.getIdMateriaDeTrabajo());
				ponerArbol(null);
			}
		});
		btnImportar.setText("Importar");
		btnImportar.setToolTipText("Importar indice de la materia desde una archivo de texto plano.");
	}

	private void creaGrupoNodos() {
	}

	private void creaGrupoDuracion() {
		grpDistTemporal = new Group(this, SWT.NONE);
		grpDistTemporal.setText("Distribución Temporal");
		grpDistTemporal.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false,
				false, 1, 1));
		GridLayout gl_grpDistTemporal = new GridLayout(4, false);
		gl_grpDistTemporal.verticalSpacing = 2;
		gl_grpDistTemporal.marginWidth = 2;
		gl_grpDistTemporal.marginHeight = 2;
		gl_grpDistTemporal.horizontalSpacing = 2;
		grpDistTemporal.setLayout(gl_grpDistTemporal);

		lblClase = new Label(grpDistTemporal, SWT.NONE);
		lblClase.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		lblClase.setText("Clase:");

		comboClase = new Combo(grpDistTemporal, SWT.READ_ONLY);
		comboClase.setToolTipText("Elija una clase sobre la que quiere gestionar la distribución temporal de la programación de la materia seleccionada.");
		comboClase.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				MateriaClase.fijarMateriaClase(
						comboConIdMateria.idSeleccionado(),
						comboConIdClase.idSeleccionado());
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Cambiando de Clase materiaclase ["+MateriaClase.getIdMateriaClaseDeTrabajo()+"]",false);
				disponibleTotal = MateriaClase.disponibleMateriaClase(null);
				treeConIdIndice.actualizarDuracionNodos(null);
				actualizarPorImpartir();
				if (treeConIdIndice.getPrimero()!=null)
					treeConIdIndice.seleccionar(treeConIdIndice.calculaNodoParaMinutos(MateriaClase.llevaMateriaClase(Fecha.fechaDeTrabajo)));
				actualizarDatosNodo();
				if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("Cambiando de Clase materiaclase ["+MateriaClase.getIdMateriaClaseDeTrabajo()+"]",true);
			}
		});
		GridData gd_comboClase = new GridData(SWT.FILL, SWT.CENTER, true,
				false, 3, 1);
		gd_comboClase.widthHint = 200;
		comboClase.setLayoutData(gd_comboClase);
		comboConIdClase = new ComboConId(comboClase);

		grpPorImpartir = new Group(grpDistTemporal, SWT.NONE);
		GridData gd_grpPorImpartir = new GridData(SWT.FILL, SWT.CENTER, true,
				false, 2, 1);
		gd_grpPorImpartir.widthHint = 200;
		grpPorImpartir.setLayoutData(gd_grpPorImpartir);
		GridLayout gl_grpPorImpartir = new GridLayout(2, false);
		gl_grpPorImpartir.verticalSpacing = 2;
		gl_grpPorImpartir.marginWidth = 2;
		gl_grpPorImpartir.marginHeight = 2;
		gl_grpPorImpartir.horizontalSpacing = 2;
		grpPorImpartir.setLayout(gl_grpPorImpartir);
		grpPorImpartir.setText("Por Impartir: (minutos)");

		Label lblDisponibleEtiqueta = new Label(grpPorImpartir, SWT.NONE);
		lblDisponibleEtiqueta.setText("Disponible:");

		lblDisponible = new Label(grpPorImpartir, SWT.NONE);
		lblDisponible.setToolTipText("Los minutos disponibles, según los parciales, horario y dias lectivos; para impartir clase. Y el total de minutos disponibles en todo el curso.");
		lblDisponible.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));
		lblDisponible.setText("99999/99999");

		Label lblRequeridoEtiqueta = new Label(grpPorImpartir, SWT.NONE);
		lblRequeridoEtiqueta.setText("Requerido:");

		lblRequerido = new Label(grpPorImpartir, SWT.NONE);
		lblRequerido.setToolTipText("Los minutos requeridos, según la duración de los enunciados, que quedan por impartir. Y el total de minutos requerido para impartir la programación según la duración de todos enunciados.");
		lblRequerido.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));
		lblRequerido.setText("99999/99999");

		grpNodo = new Group(grpDistTemporal, SWT.NONE);
		GridLayout gl_grpNodo = new GridLayout(2, false);
		gl_grpNodo.verticalSpacing = 2;
		gl_grpNodo.marginWidth = 2;
		gl_grpNodo.marginHeight = 2;
		gl_grpNodo.horizontalSpacing = 2;
		grpNodo.setLayout(gl_grpNodo);
		GridData gd_grpNodo = new GridData(SWT.FILL, SWT.CENTER, true, false,
				2, 1);
		gd_grpNodo.widthHint = 200;
		grpNodo.setLayoutData(gd_grpNodo);
		grpNodo.setText("Enunciado Seleccionado:");

		Label lblDuracion = new Label(grpNodo, SWT.NONE);
		lblDuracion.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false,
				false, 1, 1));
		lblDuracion.setText("Duración:");

		textDuracion = new Text(grpNodo, SWT.BORDER);
		textDuracion.setToolTipText("Introduzca la duración del enunciado seleccionado.");
		textDuracion.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true,
				false, 1, 1));
		TextoDemorado.add(textDuracion,true,5,null,null,false,treeConIdIndice,comboConIdClase);

		Label lblTerminaEtiqueta = new Label(grpNodo, SWT.NONE);
		lblTerminaEtiqueta.setText("Termina:");
		lblTermina = new Label(grpNodo, SWT.NONE);
		lblTermina.setToolTipText("El enunciado seleccionado se terminará de impartir en esta fecha.");
		lblTermina.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false,
				false, 1, 1));
		lblTermina.setText("xxx 00-xxx-0000 00:00.");
	}

	// -------------------------------------------------------------------------------------------------
	public void ponerArbol(String idNodoSeleccionado) {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNodoSeleccionado+")",false);
		if (idNodoSeleccionado==null && treeConIdIndice.selecionado() != null)
			idNodoSeleccionado = treeConIdIndice.getIdSeleccionado();
		treeConIdIndice.borrarTodo();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNodoSeleccionado+")");
		ponerNodo(null);
		if (idNodoSeleccionado!=null) if (treeConIdIndice.getNodo(idNodoSeleccionado)!=null) treeConIdIndice.seleccionar(idNodoSeleccionado);
		if (treeConIdIndice.selecionado()==null && treeConIdIndice.getPrimero()!=null)
			treeConIdIndice.seleccionar(treeConIdIndice.calculaNodoParaMinutos(MateriaClase.llevaMateriaClase(Fecha.fechaDeTrabajo)));
		treeConIdIndice.fijarFoco();
		actualizarDatosNodo();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+idNodoSeleccionado+") fin",true);
	}

	public void ponerNodo(TreeItem nodo) {
		Vector<Vector<String>> nodosHijo = BBDD.consultarProgramacionNodoHijos(
				((nodo == null) ? null : treeConIdIndice.getId(nodo)),
				comboConIdMateria.idSeleccionado());
		if (nodosHijo!=null){
			if (nodosHijo.size() > 0) {
				String sangria = "";
				if (PCuaderno.noti) for (int j = treeConIdIndice.nivel(nodo); j > 0; j--)
					sangria += "  ";
				for (int i = 0; i < nodosHijo.size(); i++) {
					TreeItem hijo = null;
					if (nodo == null) {
						hijo = new TreeItem(treeIndice, SWT.NONE);
					} else {
						hijo = new TreeItem(nodo, SWT.NONE);
					}
					hijo.setText(nodosHijo.get(i).get(4));
					treeConIdIndice.add(hijo, nodosHijo.get(i).get(0));
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar(sangria + nodosHijo.get(i).get(2) + ": ("
							+ nodosHijo.get(i).get(0) + ") "
							+ nodosHijo.get(i).get(4));
					ponerNodo(hijo);
				}
			} else {
				if (nodo != null) {
					if (comboConIdClase.idSeleccionado()!=null) {
						Vector<Vector<String>> nodoInfo = BBDD
								.consultarProgramacionDuracionNodo(
										treeConIdIndice.getId(nodo),
										comboConIdClase.idSeleccionado());
						if (nodoInfo.size() > 0)
							treeConIdIndice.actualizaDuracion(nodo,
									Integer.valueOf(nodoInfo.get(0).get(2)));
						else
							treeConIdIndice.actualizaDuracion(nodo, new Integer(0));
					}
				}
			}
		}
	}

	public void actualizarDatosNodo() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		TreeItem seleccionado = treeConIdIndice.selecionado();
		TreeItem nodoHermanoAnterior = treeConIdIndice.getHermanoAnterior(seleccionado);
		TreeItem nodoHermanoPosterior = treeConIdIndice.getHermanoPosterior(seleccionado);
		TreeItem nodoPadre = treeConIdIndice.getPadre(seleccionado);
		btnAdelantarNodo.setEnabled(nodoHermanoAnterior != null);
		btnRetrasarNodo.setEnabled(nodoHermanoPosterior != null);
		btnBajarNodo.setEnabled(nodoHermanoPosterior != null || nodoHermanoAnterior != null);
		btnSubirNodo.setEnabled(nodoPadre != null);
		btnCrearHermano.setEnabled(seleccionado != null);
		btnBorrarNodo.setEnabled(seleccionado != null);
		btnCrearNodoHijo.setEnabled(comboConIdMateria.idSeleccionado()!=null);
		if (seleccionado != null && comboConIdClase.idSeleccionado()!=null) {
			Vector<Vector<String>> infoNodo = BBDD.consultarProgramacionNodo(treeConIdIndice.getIdSeleccionado());
			TextoDemorado.modificaSinActualizar(textSumario, infoNodo.get(0).get(5));
			Integer duracion=treeConIdIndice.getDuracion(seleccionado);
			if (duracion==null) duracion=0;
			TextoDemorado.modificaSinActualizar(textDuracion, duracion.toString());
			if (treeConIdIndice.seleccionadoTieneHijos())
				textDuracion.setEnabled(false);
		} else {
			textSumario.setEnabled(false);
			textSumario.setText("");
			textDuracion.setEnabled(false);
			textDuracion.setText("");
		}
		btnImportar.setEnabled(comboConIdClase.idSeleccionado()!=null);
		actualizarTerminaNodo();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",true);
	}

	public void actualizarTerminaNodo() {
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",false);
		TreeItem seleccionado = treeConIdIndice.selecionado();
		//System.out.println("seleccionado="+seleccionado);
		if (seleccionado != null) {
			String fecha=Fecha.formaFechaDiaHora(MateriaClase.fechaDuracionMateriaClase(
					treeConIdIndice.calculaHastaFinNodo(seleccionado)));
			if (fecha==null) fecha = "";
			lblTermina.setText(fecha);
		} else {
			lblTermina.setText("");
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("()",true);
	}

	public void actualizarPorImpartir() {
		Integer dispPorImpartir = MateriaClase.disponibleMateriaClase(Calendar.getInstance());
		lblDisponible.setText(dispPorImpartir + "/" + disponibleTotal);
		Integer requeridoTotal = treeConIdIndice.getDuracionTotal();
		Integer requPorImpartir = (requeridoTotal - (disponibleTotal - dispPorImpartir));
		lblRequerido.setText(((requPorImpartir > 0) ? requPorImpartir : "0")
				+ "/" + requeridoTotal);
	}

	public void actualizarClase() {
		comboConIdClase.rellenarClases(comboConIdMateria.idSeleccionado(),null,null);
		disponibleTotal = MateriaClase.disponibleMateriaClase(null);
		actualizarPorImpartir();
	}
}
