/** Copyright 2012
*
* Author: Ismael PONCE GORDILLO
*
* Licensed under the EUPL, Version 1.1 or – as soon they will be
* approved by the European Commission – subsequent versions of the
* EUPL (the "Licence"); you may not use this work except in
* compliance with the Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl/licence-eupl
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the Licence is distributed on an "AS
* IS" BASIS, * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing permissions
* and limitations under the Licence.
*/
import java.util.Vector;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

public class TreeConId {
	private Tree arbol=null;
	private Vector<TreeItem> nodos = new Vector<TreeItem>();
	private Vector<String> ids = new Vector<String>();
	public void add(TreeItem nodo, String id){nodos.add(nodo);ids.add(id);}
	public TreeItem getNodo(String id){Integer x=ids.indexOf(id);return ((x>=0)?nodos.get(x):null);}
	public String getId(TreeItem nodo){Integer x=nodos.indexOf(nodo);return ((x>=0)?ids.get(x):null);}
	public TreeConId(Tree arbol){this.arbol=arbol;}
	public void fijarFoco(){arbol.setFocus();}
	public String getIdSeleccionado() {
		String id=null;
		if (arbol!=null) {
			if (arbol.getSelection().length>0) {
				if (nodos.indexOf(arbol.getSelection()[0])>-1) {
					id=ids.get(nodos.indexOf(arbol.getSelection()[0]));
					//System.out.println("TreeConId getIdSeleccionado seleccionado = "+id);
				} else {
					System.out.println("TreeConId.getIdSeleccionado - seleccionado "+arbol.getSelection()[0].getText()+"("+arbol.getSelection()[0].hashCode()+")"+" no encontrado en lista de nodos");
					imprimeNodos();
				}
			} else System.out.println("TreeConId.getIdSeleccionado - no hay seleccionados");
		} else System.out.println("TreeConId.getIdSeleccionado - arbol==null");
		return id;}
	public TreeItem getPrimero() {return ((nodos.size()>0)?nodos.get(0):null);}
	public void borrarTodo(){nodos.removeAllElements();ids.removeAllElements();arbol.removeAll();}
	public void borrarNodosHijo(TreeItem nodo) {
		for (int i=0,hijos=nodo.getItems().length;i<hijos;i++) borrarNodo(nodo.getItems()[0]);
	}
	public void borrarNodo(TreeItem nodo){
		for (int i=0,hijos=nodo.getItems().length;i<hijos;i++){
			borrarNodo(nodo.getItem(0));
		}
		int x = nodos.indexOf(nodo);
		nodos.remove(x);
		ids.remove(x);
		nodo.dispose();
	}
	public void seleccionar(TreeItem nodo){
		if (nodo!=null) {
			expandir(nodo);
			arbol.select(nodo);
			arbol.setTopItem(nodo);
		} else if (getPrimero()!=null) arbol.select(getPrimero());
	}
	public void seleccionar(String idNodo) {TreeItem nodo=getNodo(idNodo);seleccionar(nodo);}
	public TreeItem selecionado(){
		TreeItem nodo=null;
		if (arbol.getSelection().length>0) nodo=arbol.getSelection()[0];
		return nodo;}
	public boolean seleccionadoTieneHijos(){return arbol.getSelection()[0].getItemCount()>0;}
	public boolean tieneHijos(TreeItem nodo) {return nodo.getItemCount()>0;}
	public void expandir(String idNodo){TreeItem nodo = getNodo(idNodo);expandir(nodo);}
	public void expandir(TreeItem nodo){
		if (nodo!=null) {
			if (!nodo.getExpanded()) {
				if (getPadre(nodo)!=null) {
					expandir(getPadre(nodo));
				}
				nodo.setExpanded(true);
				//System.out.println("Espandiendo nodo "+getId(nodo));
			}
		}
	}
	public Integer nivel(String idNodo){
		return nivel(getNodo(idNodo));
	}
	public Integer nivel(TreeItem nodo){
		Integer n=0;
		if (nodo!=null) {
			n++;
			while (nodo.getParentItem()!=null) {nodo=nodo.getParentItem();n++;}
		}
		return n;
	}
	public Integer getDuracion(TreeItem nodo) {return (Integer)nodo.getData();}
	public void actualizaDuracion(TreeItem nodo,Integer i) {
		//System.out.print(" TreeConId actualizaDuracion [("+getId(nodo)+")<-");
		Integer anterior=((nodo.getData()==null)?0:(Integer)nodo.getData());
		Integer incremento=i-anterior;
		nodo.setData(i);
		while (nodo.getParentItem()!=null) {
			nodo=nodo.getParentItem();
			Integer x=(Integer)nodo.getData();
			if (x==null) x=0;
			x+=incremento;
			nodo.setData(x);
			//System.out.print("(id"+getId(nodo)+" "+x+")<-");
		}
		//System.out.println("]");
	}
	public Integer calculaDuracionNodo(TreeItem nodo){
		Integer suma=0;
		if (nodo.getItemCount()>0) {
			for (int i=0;i<nodo.getItems().length;i++){
				suma+=calculaDuracionNodo(nodo.getItems()[i]);
			}
		} else {
			suma+=(Integer)nodo.getData();
		}
		return suma;
	}
	public Integer getDuracionTotal(){
		Integer suma=0;
		for (int i=0;i<this.nodos.size();i++){
			if (!this.tieneHijos(this.nodos.get(i))) {
				Integer duracion=this.getDuracion(this.nodos.get(i));
				if (duracion==null) duracion=0;
				suma+=duracion;
			}
		}
		return suma;
	}
	public Integer calculaHastaFinNodo(TreeItem nodo){
		Integer suma=0;
		for (int i=0;i<this.nodos.size();i++) {
			if (this.nodos.get(i).equals(nodo)) {
				Integer duracion=this.getDuracion(nodo);
				if (duracion==null) duracion=0;
				else duracion--;
				suma+=duracion;
				break;
			} else {
				if (!this.tieneHijos(this.nodos.get(i))) {
					Integer duracion=this.getDuracion(this.nodos.get(i));
					if (duracion==null) duracion=0;
					suma+=duracion;
				}
			}
		}
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+this.getId(nodo)+") "+suma);
		return suma;
	}
	public TreeItem calculaNodoParaMinutos(int minutos){
		TreeItem nodo=null;
		int mi=minutos;
		for (int i=0;i<this.nodos.size();i++) {
			if (!this.tieneHijos(this.nodos.get(i))) {
				Integer duracion=this.getDuracion(this.nodos.get(i));
				if (duracion==null) duracion=0;
				if (mi<duracion) {
					nodo=this.nodos.get(i);
					break;
				} else {
					mi-=duracion;
				}
			}
		}
		if (nodo==null) nodo=this.nodos.lastElement();
		if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar("("+minutos+") "+((nodo!=null)?this.getId(nodo):"null"));
		return nodo;
	}
	public void imprimeNodos(){
		System.out.println("-----------------------------------("+nodos.size()+")");
		for (int i=0;i<nodos.size();i++) {
			System.out.println(" Nodo "+i+": ("+ids.get(i)+") "+nodos.get(i).getText()+" ("+nodos.get(i).hashCode()+")");
		}
		System.out.println("-----------------------------------");
	}
	public TreeItem getPadre(TreeItem nodo){
		TreeItem padre=null;
		if (nodo!=null) if (nodo.getParentItem()!=null) padre=nodo.getParentItem();
		return padre;
	}
	public TreeItem getHermanoAnterior(TreeItem nodo){
		TreeItem nodoHermano=null;
		TreeItem[] hermanos;
		if (nodo!=null) {
			if (nodo.getParentItem()==null) {
				hermanos = arbol.getItems();
			} else {
				hermanos = nodo.getParentItem().getItems();
			}
			if (hermanos.length>1 && !hermanos[0].equals(nodo)) {
				for (int i=1;i<hermanos.length;i++) {
					if (hermanos[i].equals(nodo)) {nodoHermano=hermanos[i-1];break;}
				}
			}
		}
		return nodoHermano;
	}
	public TreeItem getHermanoPosterior(TreeItem nodo){
		TreeItem nodoHermano=null;
		TreeItem[] hermanos;
		if (nodo!=null) {
			if (nodo.getParentItem()==null) {
				hermanos = arbol.getItems();
			} else {
				hermanos = nodo.getParentItem().getItems();
			}
			if (hermanos.length>1 && !hermanos[hermanos.length-1].equals(nodo)) {
				for (int i=hermanos.length-2;i>=0;i--) {
					if (hermanos[i].equals(nodo)) {nodoHermano=hermanos[i+1];break;}
				}
			}
		}
		return nodoHermano;
	}
	public void actualizarDuracionNodos(TreeItem nodo) {
		TreeItem[] nodosHijo=null;
		if (nodo!=null) nodosHijo = nodo.getItems();
		else nodosHijo = arbol.getItems();
		if (nodosHijo!=null) {
			if (nodosHijo.length > 0) {
				String sangria = "";
				if (PCuaderno.noti) for (int j = this.nivel(nodo); j > 0; j--) sangria += "  ";
				for (int i = 0; i < nodosHijo.length; i++) {
					if (PCuaderno.noti) PCuaderno.MiPCuaderno.notificar(sangria + nodosHijo[i].getText());
					nodosHijo[i].setData(new Integer(0));
					actualizarDuracionNodos(nodosHijo[i]);
				}
			} else {
				if (nodo != null) {
					if (MateriaClase.getIdClaseDeTrabajo()!=null) {
						Vector<Vector<String>> nodoInfo = BBDD
								.consultarProgramacionDuracionNodo(
										this.getId(nodo),
										MateriaClase.getIdClaseDeTrabajo());
						if (nodoInfo.size() > 0)
							this.actualizaDuracion(nodo,
									Integer.valueOf(nodoInfo.get(0).get(2)));
						else
							this.actualizaDuracion(nodo, new Integer(0));
					}
				}
			}
		}
	}
}
